#!/usr/local/bin/perl
#
# do argument processing
#
use Time::Local;
use Time::localtime;
use LWP::UserAgent;

$i = 0;
# $full_path = "/usr/src/dvb/programdb/";
$full_path = "/tmp/";

@channel_list = (
   [name => "3 Sat", kennung => "3sat", provider => "ZDF.vision"],
   [name => "ARD", kennung => "Das Erste", provider => "ARD"],
   [name => "ARTE", kennung => "arte", provider => "ARD"],
   [name => "ATV", kennung => "ATV", provider => "BetaDigital"],
   [name => "BBC PRIME", kennung => "BBC PRIME", provider => "BBC"],
   [name => "BBC WORLD", kennung => "BBC WORLD", provider => "ABsat"],
   [name => "BLOOMBERG TV", kennung => "Bloomberg TV Germany", provider => "Bloomberg"],
   [name => "Bayerisches Fernsehen", kennung => "Bayerisches FS", provider => "ARD"],
   [name => "Bayern Alpha", kennung => "BR-alpha", provider => "ARD"],
   [name => "Berlin 1", kennung => "B1 Berlin", provider => "ARD"],
   [name => "CNN", kennung => "CNN Int.", provider => "CNN"],
   [name => "Cartoon Network", kennung => "Cartoon Network", provider => "CanalSatlite"],
   [name => "DSF", kennung => "DSF", provider => "BetaDigital"],
   [name => "EUROSPORT", kennung => "Eurosport", provider => "ZDF.vision"],
   [name => "Eins MUX", kennung => "EinsMuXx", provider => "ARD"],
   [name => "HOT", kennung => "Home Order Television", provider => "BetaDigital"],
   [name => "Hessen 3", kennung => "hessen fernsehen", provider => "ARD"],
   [name => "Kabel 1", kennung => "KABEL1", provider => "ProSiebenSat.1"],
   [name => "Kinderkanal", kennung => "KiKa", provider => "ZDF.vision"],
   [name => "MDR", kennung => "MDR FERNSEHEN", provider => "ARD"],
   [name => "MTV", kennung => "MTV Central", provider => "MTV Networks"],
   [name => "N-TV", kennung => "n-tv", provider => "n-tv"],
   [name => "N24", kennung => "N24", provider => "ProSiebenSat.1"],
   [name => "NBC", kennung => "CNBC-NBC", provider => "CanalSatlite"],
   [name => "Niederlande 1", kennung => "NED1", provider => "CANAL+"],
   [name => "Niederlande 2", kennung => "NED2", provider => "CANAL+"],
   [name => "Niederlande 3", kennung => "NED3", provider => "CANAL+"],
   [name => "Nord 3", kennung => "N3", provider => "ARD"],
   [name => "ORB", kennung => "ORB-Fernsehen", provider => "ARD"],
   [name => "ORF 1", kennung => "ORF 1", provider => "ORF"],
   [name => "ORF 2", kennung => "ORF 2", provider => "ORF"],
   [name => "PRW 13TH Street", kennung => "13 TH STREET", provider => "Premiere World"],
   [name => "PRW Blue Movie 1", kennung => "BLUE MOVIE 1", provider => "Premiere World"],
   [name => "PRW Blue Movie 2", kennung => "BLUE MOVIE 2", provider => "Premiere World"],
   [name => "PRW Blue Movie 3", kennung => "BLUE MOVIE 3", provider => "Premiere World"],
   [name => "PRW Cine Action", kennung => "CINE ACTION", provider => "Premiere World"],
   [name => "PRW Cine Comedy", kennung => "CINE COMEDY", provider => "Premiere World"],
   [name => "PRW Classica", kennung => "CLASSICA", provider => "Premiere World"],
   [name => "PRW Comedy", kennung => "COMEDY", provider => "Premiere World"],
   [name => "PRW Discovery Channel", kennung => "DISCOVERY CHANNEL", provider => "Premiere World"],
   [name => "PRW Disney Channel", kennung => "DISNEY CHANNEL", provider => "Premiere World"],
   [name => "PRW Filmpalast", kennung => "FILMPALAST", provider => "Premiere World"],
   [name => "PRW FOX KIDS", kennung => "FOX KIDS", provider => "Premiere World"],
   [name => "PRW GoldStar", kennung => "GOLDSTAR TV", provider => "Premiere World"],
   [name => "PRW Heimatkanal", kennung => "HEIMATKANAL", provider => "Premiere World"],
   [name => "PRW Junior", kennung => "JUNIOR", provider => "Premiere World"],
   [name => "PRW K-Toon", kennung => "K-TOON", provider => "Premiere World"],
   [name => "PRW Kick 1", kennung => "KICK 1", provider => "Premiere World"],
   [name => "PRW Kick 2", kennung => "KICK 2", provider => "Premiere World"],
   [name => "PRW Kick 3", kennung => "KICK 3", provider => "Premiere World"],
   [name => "PRW Kick 4", kennung => "KICK 4", provider => "Premiere World"],
   [name => "PRW Krimi & Co", kennung => "KRIMI &CO", provider => "Premiere World"],
   [name => "PRW Planet", kennung => "PLANET", provider => "Premiere World"],
   [name => "PRW Premiere Digital", kennung => "PREMIERE", provider => "Premiere World"],
   [name => "PRW Romantic Movies", kennung => "ROMANTIC MOVIES", provider => "Premiere World"],
   [name => "PRW Sci-Fantasy", kennung => "SCI-FANTASY", provider => "Premiere World"],
   [name => "PRW Seasons", kennung => "SEASONS", provider => "Premiere World"],
   [name => "PRW Sport 1", kennung => "SPORT 1", provider => "Premiere World"],
   [name => "PRW Sport 2", kennung => "SPORT 2", provider => "Premiere World"],
   [name => "PRW Sport 3", kennung => "SPORT 3", provider => "Premiere World"],
   [name => "PRW Sport 4", kennung => "SPORT 4", provider => "Premiere World"],
   [name => "PRW Starkino", kennung => "STAR KINO", provider => "Premiere World"],
   [name => "PRW Studio Universal", kennung => "STUDIO UNIVERSAL", provider => "Premiere World"],
   [name => "PRW Sunset", kennung => "SUNSET", provider => "Premiere World"],
   [name => "Phoenix", kennung => "Phoenix", provider => "ARD"],
   [name => "Premiere World Beate Uhse TV", kennung => "BEATE-UHSE.TV", provider => "Premiere World"],
   [name => "Pro Sieben", kennung => "ProSieben", provider => "ProSiebenSat.1"],
   [name => "QVC Deutschland", kennung => "QVC GERMANY", provider => "QVC"],
   [name => "RTL", kennung => "RTL Television", provider => "RTL World"],
   [name => "RTL 2", kennung => "RTL2", provider => "RTL World"],
   [name => "Sat.1", kennung => "SAT.1", provider => "ProSiebenSat.1"],
   [name => "Super RTL", kennung => "Super RTL", provider => "RTL World"],
   [name => "Sdwest 3", kennung => "SWR Fernsehen", provider => "ARD"],
   [name => "TM 3", kennung => "tm3", provider => "BetaDigital"],
   [name => "TV5 Non Francophone", kennung => "TV5 Europe", provider => "TV5"],
   [name => "TW1", kennung => "TW1", provider => "ORF"],
   [name => "VH-1", kennung => "VH-1 Germany", provider => "MTV Networks"],
   [name => "Viva", kennung => "VIVA", provider => "VIVA Fernsehen GmbH & Co. KG"],
   [name => "VIVA 2", kennung => "VIVA ZWEI", provider => "VIVA Fernsehen GmbH & Co. KG"],
   [name => "Vox", kennung => "VOX", provider => "VOX"],
   [name => "WDR Fernsehen", kennung => "WDR FERNSEHEN", provider => "ARD"],
   [name => "ZDF", kennung => "ZDF", provider => "ZDF.vision"],
   [name => "ZDF TheaterKanal", kennung => "ZDF Theaterkanal", provider => "ZDF.vision"]
);

$next_week = sprintf ("%02d.%02d.%04d", localtime(time()+7*86400)->mday,
    localtime(time()+7*86400)->mon+1, localtime(time()+7*86400)->year+1900);
$tomorrow = sprintf ("%02d.%02d.%04d", localtime(time()+86400)->mday,
    localtime(time()+86400)->mon+1, localtime(time()+86400)->year+1900);
$today = sprintf ("%02d.%02d.%04d", localtime(time())->mday,
    localtime(time())->mon+1, localtime(time())->year+1900);

$ua = new LWP::UserAgent;
$ua->agent("MSIE/5.0" . $ua->agent);

$req = new HTTP::Request GET => "http://hesdvb.sf.net/programdb/" . $today . ".gz";
$res = $ua->request($req);
if ($res->is_success) {
   open (OUTF, ">" . $full_path . $today . ".gz");
   print OUTF $res->content;
   close (OUTF);
   system ("rm -f " . $full_path . $today);
   system ("gunzip -q " . $full_path . $today . ".gz");
}
$req = new HTTP::Request GET => "http://hesdvb.sf.net/programdb/" . $tomorrow . ".gz";
$res = $ua->request($req);
if ($res->is_success) {
   open (OUTF, ">" . $full_path . $tomorrow . ".gz");
   print OUTF $res->content;
   close (OUTF);
   system ("rm -f " . $full_path . $tomorrow);
   system ("gunzip -q " . $full_path . $tomorrow . ".gz");
}

system ("cat " . $full_path . $today .
        " " . $full_path . $tomorrow .
        " | sort -n > " . $full_path . "bla");

open (OUTF, ">" . $full_path . "dtvdb_prepare_events.psql") || die ("cannot open file dtvdb_prepare_events.psql");
print OUTF "DROP TABLE events;\n";
print OUTF "CREATE TABLE events (ID int8, CHID int8, NAME varchar(256), TYPE varchar(256), SHDESC varchar(1024), EXDESC varchar(8104), START int8, DURA int8, SOURCE varchar(64));\nCOPY events FROM '" . $full_path . "dtvdb' USING DELIMITERS '|';";
close (OUTF);

open (OUTF, ">" . $full_path . "dtvdb") || die ("cannot open file dtvdb");

open (INF, "<" . $full_path . "bla") || die ("cannot open file bla");
while (<INF>) {
   chomp;
   @line = split (/\|/);
      #
      #  Chan ($1), Start ($2), Dura ($3), Descr ($4), Type ($5),
      #  ShortText ($6), ExtendedText ($7)
      #
      $start = $line[1]; $chan = $line[0]; $dura = $line[2]; $descr = $line[3];
      $type = $line[4]; $short = $line[5]; $extended = $line[6];

      foreach $tmp (@channel_list)
      {
         %channel = @$tmp;
         if ($channel{name} eq $chan)
         {
            $chid = &xHashKey ($channel{kennung}) +
                    32768 * &xHashKey ($channel{provider});
            print OUTF ($id++ . "|" . $chid . "|" . $descr . "|" . $type .
                   "|" . $short . "|" . $extended . "|" . $start . "|0|\n");
            break;
         }
      }
}
close (INF);
close (OUTF);

system ("rm -f " . $full_path . "bla");
system ("psql dtvdb < " . $full_path . "dtvdb_prepare_events.psql");
system ("rm -f " . $full_path . "dtvdb");

exit (0);

sub xHashKey {
   my $name = shift(@_);
   my ($char); my($key) = 0; my($value);

   foreach $char (split (//, $name)) {
      $value = (($key >> 8) ^ ord($char)) & 0xFF;
      $value = $value ^ ($value >> 4);
      $key = 0xFFFF & (($key << 8) ^ $value ^ ($value << 5) ^ ($value << 12));
   }
   return $key;
}

