##############################################################
###                                                        ###
### user_menu.dcl: template for user defined menus         ###
###                                                        ###
##############################################################

## $Revision: 1.4 $
## $Date: 2001/06/16 14:42:03 $
## $Author: hakenes $
##
##   (C) 2001 Rolf Hakenes <hakenes@hippomi.de>, under the GNU GPL.
##
## dtv is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## dtv is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You may have received a copy of the GNU General Public License
## along with dtv; see the file COPYING.  If not, write to the
## Free Software Foundation, Inc., 59 Temple Place - Suite 330,
## Boston, MA 02111-1307, USA.

#
# There are two commands to build and destroy user menus. The first one is:
#
# 'add_menu_item <output-device> <type> <item-id> [<parent-id>] [<cmd>]'
#
# There are two types of items available, MENU for menus and submenus, CMD
# for command items. There can be only one toplevel MENU item at once (leaving
# out the parent-id), all other items have to specify a parent-id where they
# belong to. Only CMD items can own a <cmd> part, where an arbitrary DCL
# command can be specified to be executed when the item is selected.
# The second command is:
#
# 'rem_menu_item <output-device> <item-id>'
#
# Item-id can be the id of any item formerly specified. If the id specifies a
# MENU item, all its sub-items are removed as well. If the toplevel id is
# given, the complete user menu tree is removed.
#

#
#  Test configuration of a user menu
#
add_menu_item $outdev1 MENU TopLevel

add_menu_item $outdev1 MENU TopTopic_1 TopLevel

add_menu_item $outdev1 CMD Sub1Topic_1 TopTopic_1 Sub1Command1
add_menu_item $outdev1 CMD Sub1Topic_2 TopTopic_1 Sub1Command2
add_menu_item $outdev1 CMD Sub1Topic_3 TopTopic_1 Sub1Command3
add_menu_item $outdev1 CMD Sub1Topic_4 TopTopic_1 Sub1Command4
add_menu_item $outdev1 CMD Sub1Topic_5 TopTopic_1 Sub1Command5
add_menu_item $outdev1 CMD Sub1Topic_6 TopTopic_1 Sub1Command6
add_menu_item $outdev1 CMD Sub1Topic_7 TopTopic_1 Sub1Command7
add_menu_item $outdev1 CMD Sub1Topic_8 TopTopic_1 Sub1Command8
add_menu_item $outdev1 CMD Sub1Topic_9 TopTopic_1 Sub1Command9
add_menu_item $outdev1 CMD Sub1Topic_10 TopTopic_1 Sub1Command10
add_menu_item $outdev1 CMD Sub1Topic_11 TopTopic_1 Sub1Command11
add_menu_item $outdev1 CMD Sub1Topic_12 TopTopic_1 Sub1Command12
add_menu_item $outdev1 CMD Sub1Topic_13 TopTopic_1 Sub1Command13
add_menu_item $outdev1 CMD Sub1Topic_14 TopTopic_1 Sub1Command14
add_menu_item $outdev1 CMD Sub1Topic_15 TopTopic_1 Sub1Command15
add_menu_item $outdev1 CMD Sub1Topic_16 TopTopic_1 Sub1Command16
add_menu_item $outdev1 CMD Sub1Topic_17 TopTopic_1 Sub1Command17

add_menu_item $outdev1 MENU TopTopic_2 TopLevel

add_menu_item $outdev1 MENU Sub12Topic_1 TopTopic_2

add_menu_item $outdev1 MENU Sub11Topic_1 Sub12Topic_1

add_menu_item $outdev1 CMD Sub11Topic_15 Sub11Topic_1 Sub11Command15
add_menu_item $outdev1 CMD Sub11Topic_16 Sub11Topic_1 Sub11Command16
add_menu_item $outdev1 CMD Sub11Topic_17 Sub11Topic_1 Sub11Command17

add_menu_item $outdev1 MENU Sub11Topic_2 Sub11Topic_1
add_menu_item $outdev1 MENU Sub11Topic_3 Sub11Topic_1
add_menu_item $outdev1 MENU Sub11Topic_4 Sub11Topic_1

add_menu_item $outdev1 MENU Sub12Topic_2 TopTopic_2
add_menu_item $outdev1 MENU Sub12Topic_3 TopTopic_2
add_menu_item $outdev1 MENU Sub12Topic_4 TopTopic_2

add_menu_item $outdev1 MENU TopTopic_3 TopLevel 1
add_menu_item $outdev1 CMD  TopTopic_4 TopLevel TopCommand1
add_menu_item $outdev1 CMD  TopTopic_5 TopLevel TopCommand2

