//////////////////////////////////////////////////////////////
///                                                        ///
/// prototypes.h: prototypes for non-static functions      ///
///                                                        ///
//////////////////////////////////////////////////////////////

// $Revision: 1.5 $
// $Date: 2001/06/23 16:33:40 $
// $Author: hakenes $
//
//   (C) 2001 Rolf Hakenes <hakenes@hippomi.de>, under the GNU GPL.
//
// dtv_scan is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// dtv_scan is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You may have received a copy of the GNU General Public License
// along with dtv_scan; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

#include <stdio.h>
#include <time.h>

#include <liblx.h>
#include <libsi.h>
#include <dcl.h>


/* dtv.c */

extern int logLevel;
extern FILE *logFile;
extern FILE *outFile;
extern FILE *vdrFile;

int main (int, char **);
void safeExit (int);

/* dtv_config.c */

extern struct LIST *AvailableSatellites;
extern struct LIST *AvailableChannels;
extern struct LIST *AvailableTransponders;
extern struct LIST *OutputDevices;
extern struct LIST *InputDevices;
extern struct LIST *CommandQueue;
extern struct LIST *GlobalOptions;

extern struct MEM_CHUNK *AvChRemember;
extern struct MEM_CHUNK *AvSatRemember;
extern struct MEM_CHUNK *AvTpRemember;
extern struct MEM_CHUNK *CommandRemember;

extern struct Option *statOption;

extern Dcl_Interp *interp;

int initConfiguration (char *);
int Dtv_Init (Dcl_Interp *);
int Dcl_DefineAvailableSatellites (ClientData, Dcl_Interp *, int, char **);
int Dcl_DefineAvailableTransponders (ClientData, Dcl_Interp *, int, char **);
int Dcl_OpenOutput (ClientData, Dcl_Interp *, int, char **);
int Dcl_SetOption (ClientData, Dcl_Interp *, int, char **);


/* scheduler.c */

int execScheduler (void);
int collectInputEvents (void);
int openInputDevices (void);
int closeOutputDevices (void);
int closeInputDevices (void);
int processCommands (void);

/* debug.c */

void debugChannels (char *);
void debugProgramInfoList (FILE *, char *, struct LIST *);
void logPrintf(int, char *, ...);

/* dvb_si.c */

int openScan(struct InputDevice *);
void closeSi(struct InputDevice *);
int getScanEvent (struct InputDevice *);
int isValidProgram (struct InputDevice *);

/* dvb_front.c */

int openDvbDevice (struct OutputDevice *);
void closeDvbDevice (struct OutputDevice *);
int setDvbChannel (struct OutputDevice *, struct Transponder *);
int processDvbCommand (struct OutputDevice *, struct Command *);
