//////////////////////////////////////////////////////////////
///                                                        ///
/// dvb_font.c: OSD font definitions                       ///
///                                                        ///
//////////////////////////////////////////////////////////////

// $Revision: 1.1 $
// $Date: 2001/06/08 09:33:38 $
// $Author: hakenes $
//
//   (C) 2001 Rolf Hakenes <hakenes@hippomi.de>, under the GNU GPL.
//
// dtv is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// dtv is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You may have received a copy of the GNU General Public License
// along with dtv; see the file COPYING.  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

static unsigned long osdFontProp[][29] = {
  {             // 32
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 33
     6, 27, 0, 0, 0, 0,
            0, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0, 0,
            0x0C, 0x0C, 0, 0,
            0, 0, 0
  },
  {             // 34
     8, 27, 0, 0, 0, 0,
            0, 0, 0xCC, 0xCC,
            0xCC, 0xCC, 0xCC, 0x44,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 35
     13, 27, 0, 0, 0, 0,
            0, 0, 0x0118, 0x0318,
            0x0318, 0x0310, 0x1FFC, 0x1FFC,
            0x0230, 0x0630, 0x0630, 0x0620,
            0x3FFC, 0x3FFC, 0x0460, 0x0C60,
            0x0C40, 0x0C40, 0, 0,
            0, 0, 0
  },
  {             // 36
     13, 27, 0, 0, 0, 0,
            0x0180, 0x0180, 0x0FF0, 0x0CB8,
            0x1998, 0x1998, 0x1980, 0x1980,
            0x0F80, 0x07E0, 0x03F8, 0x019C,
            0x018C, 0x198C, 0x198C, 0x199C,
            0x1D38, 0x0FF0, 0x0180, 0x0180,
            0x0180, 0, 0
  },
  {             // 37
     20, 27, 0, 0, 0, 0,
            0, 0, 0x038040, 0x0FE0C0,
            0x1C7180, 0x183100, 0x183300, 0x1C7200,
            0x0FE600, 0x07C400, 0x0C78, 0x18FC,
            0x19CC, 0x3186, 0x2186, 0x6186,
            0xC0FC, 0xC078, 0, 0,
            0, 0, 0
  },
  {             // 38
     15, 27, 0, 0, 0, 0,
            0, 0, 0x0780, 0x0FC0,
            0x1860, 0x1860, 0x1860, 0x0DC0,
            0x0F80, 0x0F00, 0x1F98, 0x3198,
            0x60D8, 0x6070, 0x6070, 0x7078,
            0x3FDC, 0x1F00, 0, 0,
            0, 0, 0
  },
  {             // 39
     5, 27, 0, 0, 0, 0,
            0, 0x0C, 0x0C, 0x04,
            0x04, 0x08, 0x08, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 40
     8, 27, 0, 0, 0, 0,
            0, 0x0C, 0x18, 0x18,
            0x30, 0x30, 0x30, 0x20,
            0x60, 0x60, 0x60, 0x60,
            0x60, 0x60, 0x60, 0x60,
            0x20, 0x30, 0x30, 0x10,
            0x18, 0x08, 0x08
  },
  {             // 41
     8, 27, 0, 0, 0, 0,
            0, 0x80, 0x40, 0x60,
            0x20, 0x30, 0x30, 0x30,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x30, 0x30, 0x30, 0x20,
            0x60, 0x40, 0x80
  },
  {             // 42
     9, 27, 0, 0, 0, 0,
            0, 0x20, 0x20, 0x01AC,
            0xF8, 0x70, 0xD8, 0x88,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 43
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0xC0,
            0xC0, 0xC0, 0xC0, 0xC0,
            0x1FFC, 0x1FFC, 0xC0, 0xC0,
            0xC0, 0xC0, 0, 0,
            0, 0, 0
  },
  {             // 44
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x18, 0x18, 0x08, 0x08,
            0x18, 0, 0
  },
  {             // 45
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x1FFE, 0x1FFE, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 46
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 47
     6, 27, 0, 0, 0, 0,
            0, 0x04, 0x04, 0x0C,
            0x0C, 0x08, 0x18, 0x18,
            0x10, 0x30, 0x30, 0x20,
            0x60, 0x60, 0x40, 0xC0,
            0xC0, 0x80, 0, 0,
            0, 0, 0
  },
  {             // 48
     13, 27, 0, 0, 0, 0,
            0, 0, 0x03E0, 0x07F0,
            0x0E38, 0x0C18, 0x180C, 0x180C,
            0x180C, 0x180C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x0C18, 0x0E38,
            0x07F0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 49
     13, 27, 0, 0, 0, 0,
            0, 0, 0xC0, 0xC0,
            0x03C0, 0x0FC0, 0xC0, 0xC0,
            0xC0, 0xC0, 0xC0, 0xC0,
            0xC0, 0xC0, 0xC0, 0xC0,
            0xC0, 0xC0, 0, 0,
            0, 0, 0
  },
  {             // 50
     13, 27, 0, 0, 0, 0,
            0, 0, 0x03E0, 0x0FF8,
            0x0C1C, 0x180C, 0x180C, 0x0C,
            0x18, 0x38, 0xF0, 0x03C0,
            0x0700, 0x0E00, 0x0C00, 0x1800,
            0x1FFC, 0x1FFC, 0, 0,
            0, 0, 0
  },
  {             // 51
     13, 27, 0, 0, 0, 0,
            0, 0, 0x07E0, 0x0FF0,
            0x0C38, 0x1818, 0x1818, 0x18,
            0x30, 0x01E0, 0x01F8, 0x18,
            0x0C, 0x180C, 0x180C, 0x1C1C,
            0x0FF8, 0x07E0, 0, 0,
            0, 0, 0
  },
  {             // 52
     13, 27, 0, 0, 0, 0,
            0, 0, 0x30, 0x70,
            0xF0, 0xF0, 0x01B0, 0x0330,
            0x0630, 0x0430, 0x0C30, 0x1830,
            0x1FFC, 0x1FFC, 0x30, 0x30,
            0x30, 0x30, 0, 0,
            0, 0, 0
  },
  {             // 53
     13, 27, 0, 0, 0, 0,
            0, 0, 0x0FF8, 0x0FF8,
            0x0C00, 0x0C00, 0x0C00, 0x0FE0,
            0x0FF0, 0x1C38, 0x181C, 0x0C,
            0x0C, 0x0C, 0x180C, 0x1C18,
            0x0FF0, 0x07E0, 0, 0,
            0, 0, 0
  },
  {             // 54
     13, 27, 0, 0, 0, 0,
            0, 0, 0x03E0, 0x07F0,
            0x0E18, 0x0C1C, 0x1C00, 0x1800,
            0x1BE0, 0x1FF8, 0x1E38, 0x180C,
            0x180C, 0x180C, 0x180C, 0x0C18,
            0x0FF8, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 55
     13, 27, 0, 0, 0, 0,
            0, 0, 0x1FFC, 0x1FFC,
            0x08, 0x18, 0x30, 0x60,
            0x60, 0xC0, 0xC0, 0x0180,
            0x0180, 0x0300, 0x0300, 0x0300,
            0x0700, 0x0600, 0, 0,
            0, 0, 0
  },
  {             // 56
     13, 27, 0, 0, 0, 0,
            0, 0, 0x03E0, 0x0FF0,
            0x1C38, 0x1818, 0x1818, 0x0C38,
            0x07E0, 0x07F0, 0x0E38, 0x1C1C,
            0x180C, 0x180C, 0x180C, 0x1C1C,
            0x0FF8, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 57
     13, 27, 0, 0, 0, 0,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x1818, 0x180C, 0x180C,
            0x180C, 0x1C3C, 0x0FFC, 0x03EC,
            0x0C, 0x1C, 0x1818, 0x0C38,
            0x0FF0, 0x07E0, 0, 0,
            0, 0, 0
  },
  {             // 58
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x0C, 0x0C,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x0C, 0x0C, 0, 0,
            0, 0, 0
  },
  {             // 59
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x0C, 0x0C,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x0C, 0x0C, 0x04, 0x04,
            0x0C, 0, 0
  },
  {             // 60
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0x04,
            0x1C, 0x78, 0x03C0, 0x0F00,
            0x1C00, 0x1E00, 0x03C0, 0xF0,
            0x1C, 0x04, 0, 0,
            0, 0, 0
  },
  {             // 61
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x1FFC, 0x1FFC,
            0, 0, 0x1FFC, 0x1FFC,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 62
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0x1000,
            0x1C00, 0x0780, 0x01E0, 0x7C,
            0x0C, 0x3C, 0xF0, 0x0780,
            0x1E00, 0x1000, 0, 0,
            0, 0, 0
  },
  {             // 63
     13, 27, 0, 0, 0, 0,
            0, 0x01F0, 0x07F8, 0x0E1C,
            0x0C0C, 0x0C0C, 0x0C, 0x18,
            0x30, 0x60, 0xC0, 0xC0,
            0xC0, 0, 0, 0,
            0xC0, 0xC0, 0, 0,
            0, 0, 0
  },
  {             // 64
     23, 27, 0, 0, 0, 0,
            0, 0x7E00, 0x03FFC0, 0x0781E0,
            0x0E0070, 0x1C0038, 0x383D18, 0x30FF9C,
            0x31C38C, 0x61830C, 0x63030C, 0x63030C,
            0x630618, 0x630618, 0x738E30, 0x31FFE0,
            0x38E3C0, 0x1C0000, 0x0F0000, 0x07FF00,
            0xFE00, 0, 0
  },
  {             // 65
     15, 27, 0, 0, 0, 0,
            0, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 66
     15, 27, 0, 0, 0, 0,
            0, 0x3FE0, 0x3FF8, 0x3038,
            0x300C, 0x300C, 0x300C, 0x3018,
            0x3FF0, 0x3FF8, 0x3018, 0x300C,
            0x300C, 0x300C, 0x300C, 0x3018,
            0x3FF8, 0x3FF0, 0, 0,
            0, 0, 0
  },
  {             // 67
     17, 27, 0, 0, 0, 0,
            0, 0x0FC0, 0x3FE0, 0x7070,
            0xE038, 0xC018, 0xC000, 0x018000,
            0x018000, 0x018000, 0x018000, 0x018000,
            0x018018, 0xC018, 0xE018, 0x7030,
            0x7FF0, 0x1FC0, 0, 0,
            0, 0, 0
  },
  {             // 68
     17, 27, 0, 0, 0, 0,
            0, 0xFF80, 0xFFE0, 0xC0E0,
            0xC030, 0xC030, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC030, 0xC030, 0xC0E0,
            0xFFE0, 0xFF80, 0, 0,
            0, 0, 0
  },
  {             // 69
     15, 27, 0, 0, 0, 0,
            0, 0x3FFC, 0x3FFC, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FF8, 0x3FF8, 0x3000, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FFC, 0x3FFC, 0, 0,
            0, 0, 0
  },
  {             // 70
     14, 27, 0, 0, 0, 0,
            0, 0x1FFC, 0x1FFC, 0x1800,
            0x1800, 0x1800, 0x1800, 0x1800,
            0x1FF8, 0x1FF8, 0x1800, 0x1800,
            0x1800, 0x1800, 0x1800, 0x1800,
            0x1800, 0x1800, 0, 0,
            0, 0, 0
  },
  {             // 71
     18, 27, 0, 0, 0, 0,
            0, 0x1F80, 0x7FE0, 0xE070,
            0x01C030, 0x018018, 0x038000, 0x030000,
            0x030000, 0x0303F8, 0x0303F8, 0x030018,
            0x038018, 0x018018, 0x01C038, 0xE078,
            0x7FD8, 0x1F88, 0, 0,
            0, 0, 0
  },
  {             // 72
     17, 27, 0, 0, 0, 0,
            0, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xFFF8, 0xFFF8, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0, 0,
            0, 0, 0
  },
  {             // 73
     6, 27, 0, 0, 0, 0,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 74
     12, 27, 0, 0, 0, 0,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x1818, 0x1818, 0x1C38,
            0x0FF0, 0x07E0, 0, 0,
            0, 0, 0
  },
  {             // 75
     15, 27, 0, 0, 0, 0,
            0, 0x300E, 0x301C, 0x3038,
            0x3070, 0x30E0, 0x31C0, 0x3380,
            0x3780, 0x3F80, 0x3DC0, 0x38E0,
            0x3060, 0x3030, 0x3038, 0x3018,
            0x300C, 0x300E, 0, 0,
            0, 0, 0
  },
  {             // 76
     13, 27, 0, 0, 0, 0,
            0, 0x0C00, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0C00, 0x0C00,
            0x0FFC, 0x0FFC, 0, 0,
            0, 0, 0
  },
  {             // 77
     19, 27, 0, 0, 0, 0,
            0, 0x038038, 0x038038, 0x03C038,
            0x03C078, 0x03C078, 0x036058, 0x0360D8,
            0x0360D8, 0x033098, 0x033198, 0x033198,
            0x031918, 0x031B18, 0x031B18, 0x030F18,
            0x030E18, 0x030E18, 0, 0,
            0, 0, 0
  },
  {             // 78
     17, 27, 0, 0, 0, 0,
            0, 0xC018, 0xE018, 0xF018,
            0xF018, 0xD818, 0xDC18, 0xCC18,
            0xC618, 0xC718, 0xC318, 0xC398,
            0xC198, 0xC0D8, 0xC0F8, 0xC078,
            0xC038, 0xC038, 0, 0,
            0, 0, 0
  },
  {             // 79
     18, 27, 0, 0, 0, 0,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018018, 0x01C038, 0xE070,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 80
     15, 27, 0, 0, 0, 0,
            0, 0x3FE0, 0x3FF8, 0x3018,
            0x300C, 0x300C, 0x300C, 0x300C,
            0x301C, 0x3FF8, 0x3FE0, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3000, 0x3000, 0, 0,
            0, 0, 0
  },
  {             // 81
     18, 27, 0, 0, 0, 0,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018098, 0x01C1F8, 0xE0F0,
            0x7FF0, 0x1F9C, 0x08, 0,
            0, 0, 0
  },
  {             // 82
     17, 27, 0, 0, 0, 0,
            0, 0xFFC0, 0xFFF0, 0xC038,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC030, 0xFFE0, 0xFFF0, 0xC030,
            0xC038, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC01C, 0, 0,
            0, 0, 0
  },
  {             // 83
     15, 27, 0, 0, 0, 0,
            0, 0x07C0, 0x1FF0, 0x1838,
            0x3018, 0x3008, 0x3000, 0x3800,
            0x1F00, 0x0FF0, 0xF8, 0x1C,
            0x0C, 0x600C, 0x300C, 0x3018,
            0x1FF0, 0x0FE0, 0, 0,
            0, 0, 0
  },
  {             // 84
     14, 27, 0, 0, 0, 0,
            0, 0x7FFE, 0x7FFE, 0x0180,
            0x0180, 0x0180, 0x0180, 0x0180,
            0x0180, 0x0180, 0x0180, 0x0180,
            0x0180, 0x0180, 0x0180, 0x0180,
            0x0180, 0x0180, 0, 0,
            0, 0, 0
  },
  {             // 85
     17, 27, 0, 0, 0, 0,
            0, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0x6070,
            0x7FE0, 0x1FC0, 0, 0,
            0, 0, 0
  },
  {             // 86
     15, 27, 0, 0, 0, 0,
            0, 0x600E, 0x700C, 0x300C,
            0x301C, 0x3818, 0x1818, 0x1838,
            0x1C30, 0x0C30, 0x0C70, 0x0E60,
            0x0660, 0x0660, 0x07C0, 0x03C0,
            0x03C0, 0x0180, 0, 0,
            0, 0, 0
  },
  {             // 87
     22, 27, 0, 0, 0, 0,
            0, 0x30180C, 0x30380C, 0x303C1C,
            0x383C1C, 0x183C18, 0x186618, 0x186618,
            0x1C6638, 0x0CC630, 0x0CC330, 0x0CC330,
            0x0EC370, 0x0781E0, 0x0781E0, 0x0781E0,
            0x0781C0, 0x0300C0, 0, 0,
            0, 0, 0
  },
  {             // 88
     15, 27, 0, 0, 0, 0,
            0, 0x700C, 0x301C, 0x1818,
            0x1C38, 0x0C70, 0x0660, 0x07C0,
            0x03C0, 0x0380, 0x03C0, 0x06C0,
            0x0E60, 0x1C70, 0x1838, 0x3818,
            0x701C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 89
     15, 27, 0, 0, 0, 0,
            0, 0x600E, 0x700E, 0x301C,
            0x1818, 0x1C38, 0x0C30, 0x0E60,
            0x0760, 0x03C0, 0x03C0, 0x0180,
            0x0180, 0x0180, 0x0180, 0x0180,
            0x0180, 0x0180, 0, 0,
            0, 0, 0
  },
  {             // 90
     14, 27, 0, 0, 0, 0,
            0, 0x3FFC, 0x3FFC, 0x1C,
            0x18, 0x38, 0x70, 0xE0,
            0x01C0, 0x0180, 0x0380, 0x0700,
            0x0E00, 0x0C00, 0x1C00, 0x3800,
            0x3FFC, 0x3FFC, 0, 0,
            0, 0, 0
  },
  {             // 91
     6, 27, 0, 0, 0, 0,
            0, 0x3E, 0x3E, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x3E, 0x3E
  },
  {             // 92
     6, 27, 0, 0, 0, 0,
            0, 0x80, 0xC0, 0x40,
            0x40, 0x60, 0x20, 0x20,
            0x20, 0x10, 0x10, 0x10,
            0x08, 0x08, 0x08, 0x0C,
            0x04, 0x04, 0, 0,
            0, 0, 0
  },
  {             // 93
     6, 27, 0, 0, 0, 0,
            0, 0x3C, 0x3C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x3C, 0x3C
  },
  {             // 94
     11, 27, 0, 0, 0, 0,
            0, 0, 0xE0, 0xE0,
            0x01A0, 0x01B0, 0x0110, 0x0318,
            0x0218, 0x0608, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 95
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x7FFE, 0x7FFE, 0
  },
  {             // 96
     5, 27, 0, 0, 0, 0,
            0, 0, 0x04, 0x08,
            0x08, 0x0C, 0x0C, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 97
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 98
     13, 27, 0, 0, 0, 0,
            0, 0x1800, 0x1800, 0x1800,
            0x1800, 0x1800, 0x1BE0, 0x1FF8,
            0x1E38, 0x1C1C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x1C1C, 0x1E38,
            0x1FF8, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 99
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x01F0, 0x07F8,
            0x061C, 0x0C0C, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0C0C, 0x061C,
            0x07F8, 0x01F0, 0, 0,
            0, 0, 0
  },
  {             // 100
     13, 27, 0, 0, 0, 0,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x03D8, 0x0FF8,
            0x0C38, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x0C38,
            0x0FF8, 0x07C0, 0, 0,
            0, 0, 0
  },
  {             // 101
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03E0, 0x07F0,
            0x0C38, 0x181C, 0x180C, 0x1FFC,
            0x1FFC, 0x1800, 0x1808, 0x0C18,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 102
     6, 27, 0, 0, 0, 0,
            0, 0x0E, 0x1E, 0x18,
            0x18, 0x18, 0x7E, 0x7E,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 103
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03D8, 0x0FF8,
            0x0C38, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x0C38,
            0x07F8, 0x03D8, 0x18, 0x1818,
            0x0C30, 0x0FF0, 0x07C0
  },
  {             // 104
     13, 27, 0, 0, 0, 0,
            0, 0x0C00, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0DF0, 0x0FF8,
            0x0E18, 0x0C18, 0x0C18, 0x0C18,
            0x0C18, 0x0C18, 0x0C18, 0x0C18,
            0x0C18, 0x0C18, 0, 0,
            0, 0, 0
  },
  {             // 105
     5, 27, 0, 0, 0, 0,
            0, 0x18, 0x18, 0,
            0, 0, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 106
     5, 27, 0, 0, 0, 0,
            0, 0x0C, 0x0C, 0,
            0, 0, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x3C, 0x38
  },
  {             // 107
     12, 27, 0, 0, 0, 0,
            0, 0x0C00, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0C18, 0x0C30,
            0x0C60, 0x0CC0, 0x0FC0, 0x0FC0,
            0x0E60, 0x0C70, 0x0C30, 0x0C18,
            0x0C1C, 0x0C0C, 0, 0,
            0, 0, 0
  },
  {             // 108
     5, 27, 0, 0, 0, 0,
            0, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0x0C, 0x0C,
            0x0C, 0x0C, 0, 0,
            0, 0, 0
  },
  {             // 109
     19, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x037CF8, 0x03FFFC,
            0x03870C, 0x03060C, 0x03060C, 0x03060C,
            0x03060C, 0x03060C, 0x03060C, 0x03060C,
            0x03060C, 0x03060C, 0, 0,
            0, 0, 0
  },
  {             // 110
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x09F0, 0x0FF8,
            0x0E18, 0x0C18, 0x0C18, 0x0C18,
            0x0C18, 0x0C18, 0x0C18, 0x0C18,
            0x0C18, 0x0C18, 0, 0,
            0, 0, 0
  },
  {             // 111
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 112
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x1BE0, 0x1FF8,
            0x1E38, 0x1C1C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x1C1C, 0x1E38,
            0x1FF8, 0x19E0, 0x1800, 0x1800,
            0x1800, 0x1800, 0x1800
  },
  {             // 113
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03D8, 0x0FF8,
            0x0C38, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x0C38,
            0x0FF8, 0x07D8, 0x18, 0x18,
            0x18, 0x18, 0x18
  },
  {             // 114
     8, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x1C, 0x7C,
            0x70, 0x60, 0x60, 0x60,
            0x60, 0x60, 0x60, 0x60,
            0x60, 0x60, 0, 0,
            0, 0, 0
  },
  {             // 115
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03F0, 0x07F8,
            0x0C18, 0x0C00, 0x0E00, 0x07E0,
            0x01F8, 0x1C, 0x0C0C, 0x0C0C,
            0x0FF8, 0x03F0, 0, 0,
            0, 0, 0
  },
  {             // 116
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0x18,
            0x18, 0x18, 0x7E, 0x7E,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x1E, 0x1E, 0, 0,
            0, 0, 0
  },
  {             // 117
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1838,
            0x1FF8, 0x07C0, 0, 0,
            0, 0, 0
  },
  {             // 118
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x1C0C, 0x0C1C,
            0x0C18, 0x0E18, 0x0638, 0x0630,
            0x0330, 0x0360, 0x0360, 0x01E0,
            0x01C0, 0x01C0, 0, 0,
            0, 0, 0
  },
  {             // 119
     17, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x03060C, 0x01870C,
            0x018F1C, 0x018F18, 0x018D98, 0xC998,
            0xD9B0, 0xD9B0, 0x58F0, 0x70F0,
            0x70E0, 0x70E0, 0, 0,
            0, 0, 0
  },
  {             // 120
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x0C1C, 0x0618,
            0x0630, 0x0360, 0x01E0, 0x01C0,
            0x01C0, 0x03E0, 0x0370, 0x0630,
            0x0E18, 0x0C1C, 0, 0,
            0, 0, 0
  },
  {             // 121
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x0C0C, 0x0C1C,
            0x0C18, 0x0618, 0x0630, 0x0630,
            0x0330, 0x0360, 0x0360, 0x01E0,
            0x01C0, 0x01C0, 0x0180, 0x0180,
            0x0380, 0x0F00, 0x0E00
  },
  {             // 122
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x0FF8, 0x0FF8,
            0x30, 0x30, 0x60, 0xC0,
            0x0180, 0x0300, 0x0600, 0x0C00,
            0x0FFC, 0x0FFC, 0, 0,
            0, 0, 0
  },
  {             // 123
     8, 27, 0, 0, 0, 0,
            0, 0x18, 0x38, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x70, 0xE0,
            0xC0, 0x60, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x38, 0x18
  },
  {             // 124
     6, 27, 0, 0, 0, 0,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18
  },
  {             // 125
     8, 27, 0, 0, 0, 0,
            0, 0xC0, 0xE0, 0x60,
            0x60, 0x60, 0x60, 0x60,
            0x60, 0x60, 0x30, 0x38,
            0x18, 0x30, 0x60, 0x60,
            0x60, 0x60, 0x60, 0x60,
            0x60, 0xE0, 0xC0
  },
  {             // 126
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x0700, 0x0F8C, 0x08FC, 0x38,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 127
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 128
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 129
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 130
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 131
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 132
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 133
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 134
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 135
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 136
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 137
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 138
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 139
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 140
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 141
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 142
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 143
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 144
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 145
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 146
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 147
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 148
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 149
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 150
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 151
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 152
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 153
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 154
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 155
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 156
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 157
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 158
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 159
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 160
     0, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 161
     8, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x30, 0x30,
            0, 0, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30
  },
  {             // 162
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0xC0, 0xC0, 0x03F0, 0x0FF8,
            0x0E58, 0x1C4C, 0x1840, 0x1840,
            0x1880, 0x1880, 0x188C, 0x0C9C,
            0x0EB8, 0x07F0, 0xC0, 0xC0,
            0xC0, 0, 0
  },
  {             // 163
     13, 27, 0, 0, 0, 0,
            0, 0x03E0, 0x07F0, 0x0E38,
            0x1818, 0x180C, 0x180C, 0x1C00,
            0x0E00, 0x1FC0, 0x1F40, 0x0700,
            0x0300, 0x0300, 0x0600, 0x0C00,
            0x1FFC, 0x1FF8, 0, 0,
            0, 0, 0
  },
  {             // 164
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0x0408, 0x0FD8, 0x0FF8,
            0x0E38, 0x0C18, 0x0C18, 0x0E38,
            0x07F0, 0x0FD8, 0x0408, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 165
     13, 27, 0, 0, 0, 0,
            0, 0, 0x180C, 0x1818,
            0x0C18, 0x0C30, 0x0620, 0x0260,
            0x03C0, 0x1DF8, 0x1FF8, 0x0180,
            0x1FF8, 0x1FF8, 0x0180, 0x0180,
            0x0180, 0x0180, 0, 0,
            0, 0, 0
  },
  {             // 166
     6, 27, 0, 0, 0, 0,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18
  },
  {             // 167
     13, 27, 0, 0, 0, 0,
            0, 0x01E0, 0x07F0, 0x0E38,
            0x0C18, 0x0C18, 0x0E00, 0x0780,
            0x0DE0, 0x18F0, 0x1838, 0x181C,
            0x1C0C, 0x0E0C, 0x0798, 0x01F0,
            0xE0, 0x70, 0x0C30, 0x0C30,
            0x0E30, 0x07E0, 0x03C0
  },
  {             // 168
     8, 27, 0, 0, 0, 0,
            0, 0, 0xCC, 0xCC,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 169
     17, 27, 0, 0, 0, 0,
            0, 0x1F80, 0x7FE0, 0xF078,
            0x01C718, 0x038F8C, 0x0318CC, 0x063046,
            0x063006, 0x063006, 0x063006, 0x063066,
            0x0318C6, 0x031FCC, 0x01879C, 0xE078,
            0x7FF0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 170
     9, 27, 0, 0, 0, 0,
            0, 0xF0, 0x01F8, 0x18,
            0x78, 0x0198, 0x0198, 0x01FC,
            0xEC, 0x01F8, 0x01F8, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 171
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x0110, 0x0310, 0x0670, 0x0C40,
            0x0C60, 0x0730, 0x0310, 0x0110,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 172
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0x1FFE, 0x1FFE, 0x06,
            0x06, 0x06, 0x06, 0x06,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 173
     8, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0xF8,
            0xF8, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 174
     17, 27, 0, 0, 0, 0,
            0, 0x1F80, 0x7FE0, 0xF078,
            0x01FF98, 0x03BFCC, 0x03306C, 0x063066,
            0x063066, 0x063FC6, 0x063FE6, 0x063066,
            0x03306E, 0x03306C, 0x01F07C, 0xE078,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 175
     8, 27, 0, 0, 0, 0,
            0, 0, 0xFC, 0xFC,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 176
     14, 27, 0, 0, 0, 0,
            0, 0, 0x03C0, 0x07E0,
            0x0C30, 0x0C30, 0x0C30, 0x0660,
            0x07E0, 0x03C0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 177
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0xC0, 0xC0, 0xC0, 0xC0,
            0x1FFC, 0x1FFC, 0xC0, 0xC0,
            0xC0, 0xC0, 0xC0, 0,
            0x1FFC, 0x1FFC, 0, 0,
            0, 0, 0
  },
  {             // 178
     8, 27, 0, 0, 0, 0,
            0, 0, 0x78, 0xFE,
            0x86, 0x06, 0x0C, 0x30,
            0xE0, 0x80, 0xFE, 0x7E,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 179
     8, 27, 0, 0, 0, 0,
            0, 0, 0x78, 0xFC,
            0x8C, 0x0C, 0x38, 0x0C,
            0x06, 0x0186, 0xFC, 0x78,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 180
     8, 27, 0, 0, 0, 0,
            0, 0x1C, 0x38, 0x30,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 181
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1838,
            0x1FFC, 0x1FDE, 0x1800, 0x1800,
            0x1800, 0x1800, 0x1800
  },
  {             // 182
     12, 27, 0, 0, 0, 0,
            0, 0x01FE, 0x03FE, 0x07EC,
            0x07EC, 0x0FEC, 0x0FEC, 0x0FEC,
            0x0FEC, 0x07EC, 0x07EC, 0x01EC,
            0x6C, 0x6C, 0x6C, 0x6C,
            0x6C, 0x6C, 0x6C, 0x6C,
            0x6C, 0x6C, 0
  },
  {             // 183
     6, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x18, 0x18, 0x18, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 184
     8, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x10, 0x38,
            0x3C, 0xFC, 0x38
  },
  {             // 185
     8, 27, 0, 0, 0, 0,
            0, 0, 0x10, 0x70,
            0xF0, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 186
     8, 27, 0, 0, 0, 0,
            0, 0x78, 0x7C, 0xC6,
            0xC6, 0xC6, 0xC6, 0x7C,
            0x38, 0xFC, 0xFC, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 187
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x0840, 0x0C60, 0x0730, 0x0310,
            0x0330, 0x0E60, 0x0C40, 0x0840,
            0, 0, 0, 0,
            0, 0, 0
  },
  {             // 188
     20, 27, 0, 0, 0, 0,
            0, 0, 0x030060, 0x070040,
            0x0F0080, 0x030180, 0x030300, 0x030200,
            0x030618, 0x030C18, 0x030C38, 0x1878,
            0x30D8, 0x7098, 0x61FE, 0xC1FE,
            0x01C018, 0x018008, 0, 0,
            0, 0, 0
  },
  {             // 189
     20, 27, 0, 0, 0, 0,
            0, 0, 0x030040, 0x070080,
            0x0F0180, 0x030100, 0x030300, 0x030600,
            0x030C78, 0x030CFC, 0x031886, 0x3086,
            0x300C, 0x6018, 0xC060, 0xC080,
            0x0181FE, 0x03007E, 0, 0,
            0, 0, 0
  },
  {             // 190
     20, 27, 0, 0, 0, 0,
            0, 0, 0x078020, 0x0FC060,
            0x08C0C0, 0xC080, 0x038180, 0xC300,
            0x6218, 0x186418, 0x0FCC38, 0x078878,
            0x10D8, 0x3098, 0x21FE, 0x41FE,
            0x8018, 0x8008, 0, 0,
            0, 0, 0
  },
  {             // 191
     14, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x0180, 0x0180,
            0, 0, 0, 0x0180,
            0x0180, 0x0380, 0x0700, 0x0E00,
            0x0C00, 0x1800, 0x1818, 0x1818,
            0x1C38, 0x0FF0, 0x07C0
  },
  {             // 192
     15, 27, 0x0E00, 0x0700, 0x0100, 0x80,
            0, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 193
     15, 27, 0xE0, 0xC0, 0x0180, 0x0300,
            0, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 194
     15, 27, 0x0180, 0x03C0, 0x06C0, 0x0460,
            0, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 195
     15, 27, 0, 0x0720, 0x0FE0, 0x40,
            0, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 196
     15, 27, 0, 0x06E0, 0x06E0, 0,
            0, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 197
     15, 27, 0x0380, 0x03C0, 0x0240, 0x0380,
            0x0180, 0x0380, 0x03C0, 0x07C0,
            0x06C0, 0x06E0, 0x0E60, 0x0C60,
            0x0C70, 0x1C30, 0x1830, 0x1FF8,
            0x3FF8, 0x3018, 0x701C, 0x700C,
            0x600C, 0x600E, 0, 0,
            0, 0, 0
  },
  {             // 198
     23, 27, 0, 0, 0, 0,
            0, 0x01FFF8, 0x01FFF8, 0x031800,
            0x031800, 0x061800, 0x061800, 0x0E1800,
            0x0C1FF8, 0x0C1FF8, 0x181800, 0x1FF800,
            0x3FF800, 0x301800, 0x301800, 0x701800,
            0x601FFC, 0xE01FFC, 0, 0,
            0, 0, 0
  },
  {             // 199
     17, 27, 0, 0, 0, 0,
            0, 0x0FC0, 0x3FE0, 0x7070,
            0xE038, 0xC018, 0xC000, 0x018000,
            0x018000, 0x018000, 0x018000, 0x018000,
            0x018018, 0xC018, 0xC018, 0x6030,
            0x78F0, 0x1FE0, 0x0200, 0x0700,
            0x0380, 0x0F80, 0x0700
  },
  {             // 200
     15, 27, 0x0600, 0x0300, 0x0180, 0x80,
            0, 0x3FFC, 0x3FFC, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FF8, 0x3FF8, 0x3000, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FFC, 0x3FFC, 0, 0,
            0, 0, 0
  },
  {             // 201
     15, 27, 0xE0, 0xC0, 0x0180, 0x0300,
            0, 0x3FFC, 0x3FFC, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FF8, 0x3FF8, 0x3000, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FFC, 0x3FFC, 0, 0,
            0, 0, 0
  },
  {             // 202
     15, 27, 0x0180, 0x03C0, 0x0640, 0x0460,
            0, 0x3FFC, 0x3FFC, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FF8, 0x3FF8, 0x3000, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FFC, 0x3FFC, 0, 0,
            0, 0, 0
  },
  {             // 203
     15, 27, 0, 0x0660, 0x0660, 0,
            0, 0x3FFC, 0x3FFC, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FF8, 0x3FF8, 0x3000, 0x3000,
            0x3000, 0x3000, 0x3000, 0x3000,
            0x3FFC, 0x3FFC, 0, 0,
            0, 0, 0
  },
  {             // 204
     6, 27, 0x70, 0x30, 0x18, 0x0C,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 205
     6, 27, 0x06, 0x0C, 0x08, 0x18,
            0, 0x08, 0x08, 0x08,
            0x08, 0x08, 0x08, 0x08,
            0x08, 0x08, 0x08, 0x08,
            0x08, 0x08, 0x08, 0x08,
            0x08, 0x08, 0, 0,
            0, 0, 0
  },
  {             // 206
     6, 27, 0x30, 0x78, 0x4C, 0xC4,
            0, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0x30, 0x30,
            0x30, 0x30, 0, 0,
            0, 0, 0
  },
  {             // 207
     6, 27, 0, 0x66, 0x66, 0x66,
            0, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 208
     17, 27, 0, 0, 0, 0,
            0, 0xFF80, 0xFFE0, 0xC0F0,
            0xC030, 0xC030, 0xC018, 0xC018,
            0x03FC18, 0x03FC18, 0xC018, 0xC018,
            0xC018, 0xC030, 0xC030, 0xC0E0,
            0xFFE0, 0xFF80, 0, 0,
            0, 0, 0
  },
  {             // 209
     17, 27, 0, 0x0EC0, 0x1FC0, 0x0180,
            0, 0xC018, 0xE018, 0xF018,
            0xF018, 0xD818, 0xDC18, 0xCC18,
            0xC618, 0xC718, 0xC318, 0xC398,
            0xC198, 0xC0D8, 0xC0F8, 0xC078,
            0xC038, 0xC038, 0, 0,
            0, 0, 0
  },
  {             // 210
     18, 27, 0x1800, 0x0C00, 0x0600, 0x0200,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018018, 0x01C038, 0xE070,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 211
     18, 27, 0x0180, 0x0300, 0x0600, 0x0400,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018018, 0x01C038, 0xE070,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 212
     18, 27, 0x0600, 0x0F00, 0x0900, 0x1080,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018018, 0x01C038, 0xE070,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 213
     18, 27, 0, 0x1CC0, 0x1F80, 0x0180,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018018, 0x01C038, 0xE070,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 214
     18, 27, 0, 0x1980, 0x1980, 0,
            0, 0x1F80, 0x7FE0, 0xE0F0,
            0x01C038, 0x018018, 0x03801C, 0x03000C,
            0x03000C, 0x03000C, 0x03000C, 0x03000C,
            0x03000C, 0x018018, 0x01C038, 0xE070,
            0x7FE0, 0x1F80, 0, 0,
            0, 0, 0
  },
  {             // 215
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0x0408, 0x0E18, 0x0730, 0x03E0,
            0x01C0, 0x01E0, 0x0370, 0x0638,
            0x0418, 0, 0, 0,
            0, 0, 0
  },
  {             // 216
     18, 27, 0, 0, 0, 0,
            0, 0x1F8C, 0x7FE8, 0xE070,
            0x01C038, 0x018058, 0x03809C, 0x03018C,
            0x03030C, 0x03060C, 0x030C0C, 0x03180C,
            0x03300C, 0x01E018, 0x01C038, 0xE070,
            0x03FFE0, 0x023F80, 0, 0,
            0, 0, 0
  },
  {             // 217
     17, 27, 0x1C00, 0x0C00, 0x0600, 0x0300,
            0, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0x6070,
            0x7FE0, 0x1FC0, 0, 0,
            0, 0, 0
  },
  {             // 218
     17, 27, 0x0180, 0x0300, 0x0200, 0x0400,
            0, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0x6070,
            0x7FE0, 0x1FC0, 0, 0,
            0, 0, 0
  },
  {             // 219
     17, 27, 0x0700, 0x0700, 0x0D80, 0x1880,
            0, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0x6070,
            0x7FE0, 0x1FC0, 0, 0,
            0, 0, 0
  },
  {             // 220
     17, 27, 0, 0x1D80, 0x1D80, 0,
            0, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0xC018,
            0xC018, 0xC018, 0xC018, 0x6070,
            0x7FE0, 0x1FC0, 0, 0,
            0, 0, 0
  },
  {             // 221
     15, 27, 0xE0, 0xC0, 0x0180, 0x0300,
            0, 0x600E, 0x700E, 0x301C,
            0x1818, 0x1C38, 0x0C30, 0x0E60,
            0x0760, 0x03C0, 0x03C0, 0x0180,
            0x0180, 0x0180, 0x0180, 0x0180,
            0x0180, 0x0180, 0, 0,
            0, 0, 0
  },
  {             // 222
     15, 27, 0, 0, 0, 0,
            0, 0x3000, 0x3000, 0x3000,
            0x3FF0, 0x3FF8, 0x301C, 0x300C,
            0x300C, 0x300C, 0x300C, 0x3038,
            0x3FF8, 0x3FF0, 0x3000, 0x3000,
            0x3000, 0x3000, 0, 0,
            0, 0, 0
  },
  {             // 223
     14, 27, 0, 0, 0, 0,
            0, 0x03E0, 0x07F0, 0x0E38,
            0x0C18, 0x0C18, 0x0C18, 0x0C38,
            0x0CE0, 0x0CF0, 0x0C18, 0x0C0C,
            0x0C0C, 0x0C0C, 0x0C0C, 0x0C18,
            0x0CF8, 0x0CE0, 0, 0,
            0, 0, 0
  },
  {             // 224
     13, 27, 0, 0, 0, 0,
            0, 0x0300, 0x0180, 0x80,
            0, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 225
     13, 27, 0, 0, 0, 0,
            0, 0x60, 0xC0, 0x0180,
            0, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 226
     13, 27, 0, 0, 0, 0,
            0, 0x01C0, 0x0340, 0x0260,
            0, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 227
     13, 27, 0, 0, 0, 0,
            0, 0x0300, 0x07F0, 0x04E0,
            0, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 228
     13, 27, 0, 0, 0, 0,
            0, 0, 0x0760, 0x0760,
            0, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 229
     13, 27, 0, 0, 0, 0,
            0x0180, 0x01C0, 0x0240, 0x03C0,
            0x0180, 0, 0x03E0, 0x0FF8,
            0x0C18, 0x0818, 0x18, 0x03F8,
            0x0F98, 0x1C18, 0x1818, 0x1838,
            0x1FFC, 0x07DC, 0, 0,
            0, 0, 0
  },
  {             // 230
     20, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x01F3F0, 0x07FFF8,
            0x060E1C, 0x040C0C, 0x1C0C, 0x03FFFC,
            0x07EFFC, 0x0E0C00, 0x0C0C0C, 0x0C1E1C,
            0x0FF7F8, 0x07C3F0, 0, 0,
            0, 0, 0
  },
  {             // 231
     12, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x01F0, 0x07F8,
            0x061C, 0x0C0C, 0x0C00, 0x0C00,
            0x0C00, 0x0C00, 0x0C0C, 0x061C,
            0x0738, 0x03F0, 0x80, 0xE0,
            0xE0, 0x03E0, 0xC0
  },
  {             // 232
     13, 27, 0, 0, 0, 0,
            0, 0x0300, 0x0180, 0x80,
            0, 0, 0x03E0, 0x07F0,
            0x0C38, 0x181C, 0x180C, 0x1FFC,
            0x1FFC, 0x1800, 0x1808, 0x0C18,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 233
     13, 27, 0, 0, 0, 0,
            0, 0x70, 0xE0, 0x0180,
            0, 0, 0x03E0, 0x07F0,
            0x0C38, 0x181C, 0x180C, 0x1FFC,
            0x1FFC, 0x1800, 0x1808, 0x0C18,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 234
     13, 27, 0, 0, 0, 0,
            0, 0x01C0, 0x0160, 0x0320,
            0, 0, 0x03E0, 0x07F0,
            0x0C38, 0x181C, 0x180C, 0x1FFC,
            0x1FFC, 0x1800, 0x1808, 0x0C18,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 235
     13, 27, 0, 0, 0, 0,
            0, 0, 0x0370, 0x0370,
            0, 0, 0x03E0, 0x07F0,
            0x0C38, 0x181C, 0x180C, 0x1FFC,
            0x1FFC, 0x1800, 0x1808, 0x0C18,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 236
     6, 27, 0, 0, 0, 0,
            0, 0x70, 0x30, 0x18,
            0, 0, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 237
     6, 27, 0, 0, 0, 0,
            0, 0x0E, 0x0C, 0x18,
            0, 0, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 238
     6, 27, 0, 0, 0, 0,
            0, 0x1C, 0x3C, 0x66,
            0, 0, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 239
     6, 27, 0, 0, 0, 0,
            0, 0, 0x66, 0x66,
            0, 0, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0x18, 0x18,
            0x18, 0x18, 0, 0,
            0, 0, 0
  },
  {             // 240
     13, 27, 0, 0, 0, 0,
            0, 0x0420, 0x07C0, 0x0780,
            0x04C0, 0xE0, 0x03F0, 0x0FF8,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF8, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 241
     13, 27, 0, 0, 0, 0,
            0, 0x0300, 0x07F0, 0x04E0,
            0, 0, 0x09F0, 0x0FF8,
            0x0E18, 0x0C18, 0x0C18, 0x0C18,
            0x0C18, 0x0C18, 0x0C18, 0x0C18,
            0x0C18, 0x0C18, 0, 0,
            0, 0, 0
  },
  {             // 242
     13, 27, 0, 0, 0, 0,
            0, 0x0300, 0x0180, 0x80,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 243
     13, 27, 0, 0, 0, 0,
            0, 0x60, 0xC0, 0x0180,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 244
     13, 27, 0, 0, 0, 0,
            0, 0x01C0, 0x0340, 0x0260,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 245
     13, 27, 0, 0, 0, 0,
            0, 0x0300, 0x07F0, 0x04E0,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 246
     13, 27, 0, 0, 0, 0,
            0, 0, 0x0760, 0x0760,
            0, 0, 0x03E0, 0x0FF0,
            0x0C38, 0x181C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x181C, 0x0C38,
            0x0FF0, 0x03E0, 0, 0,
            0, 0, 0
  },
  {             // 247
     13, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0xC0,
            0xC0, 0, 0, 0,
            0x1FFC, 0x1FFC, 0, 0,
            0xC0, 0xC0, 0, 0,
            0, 0, 0
  },
  {             // 248
     14, 27, 0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0x07C8, 0x1FF0,
            0x1830, 0x3078, 0x3098, 0x3198,
            0x3318, 0x3618, 0x3438, 0x1870,
            0x1FE0, 0x27C0, 0x2000, 0,
            0, 0, 0
  },
  {             // 249
     13, 27, 0, 0, 0, 0,
            0, 0x0700, 0x0180, 0x80,
            0, 0, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1838,
            0x1FF8, 0x07C0, 0, 0,
            0, 0, 0
  },
  {             // 250
     13, 27, 0, 0, 0, 0,
            0, 0xE0, 0xC0, 0x0180,
            0, 0, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1838,
            0x1FF8, 0x07C0, 0, 0,
            0, 0, 0
  },
  {             // 251
     13, 27, 0, 0, 0, 0,
            0, 0x01C0, 0x0340, 0x0260,
            0, 0, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1838,
            0x1FF8, 0x07C0, 0, 0,
            0, 0, 0
  },
  {             // 252
     13, 27, 0, 0, 0, 0,
            0, 0, 0x06E0, 0x0260,
            0, 0, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1818,
            0x1818, 0x1818, 0x1818, 0x1838,
            0x1FF8, 0x07C0, 0, 0,
            0, 0, 0
  },
  {             // 253
     12, 27, 0, 0, 0, 0,
            0, 0x70, 0xE0, 0x80,
            0, 0, 0x0C0C, 0x0C1C,
            0x0C18, 0x0618, 0x0630, 0x0630,
            0x0330, 0x0360, 0x0360, 0x01E0,
            0x01C0, 0x01C0, 0x0180, 0x0180,
            0x0380, 0x0F00, 0x0E00
  },
  {             // 254
     13, 27, 0, 0, 0, 0,
            0, 0, 0x1800, 0x1800,
            0x1800, 0x1800, 0x1BE0, 0x1FF8,
            0x1E38, 0x1C1C, 0x180C, 0x180C,
            0x180C, 0x180C, 0x1C1C, 0x1E38,
            0x1FF8, 0x19E0, 0x1800, 0x1800,
            0x1800, 0x1800, 0x1800
  },
  {             // 255
     12, 27, 0, 0, 0, 0,
            0, 0, 0x0370, 0x0370,
            0, 0, 0x0C0C, 0x0C1C,
            0x0C18, 0x0618, 0x0630, 0x0630,
            0x0330, 0x0360, 0x0360, 0x01E0,
            0x01C0, 0x01C0, 0x0180, 0x0180,
            0x0380, 0x0F00, 0x0E00
  },
};

static unsigned long osdFontFixed[][28] = {
  {             // 32
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 33
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x0780, 0x0780,
             0x0780, 0x0780, 0x0780, 0x0780,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0, 0x0300, 0x0300,
             0x0300, 0, 0, 0,
             0, 0
  },
  {             // 34
     15, 26, 0, 0, 0, 0,
             0, 0x1DC0, 0x1DC0, 0x1DC0,
             0x1DC0, 0x0880, 0x0880, 0x0880,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 35
     15, 26, 0, 0, 0, 0,
             0x0660, 0x0660, 0x0660, 0x0660,
             0x0660, 0x0660, 0x3FF8, 0x3FF8,
             0x0CC0, 0x0CC0, 0x0CC0, 0x7FF0,
             0x7FF0, 0x1980, 0x1980, 0x1980,
             0x1980, 0x1980, 0x1980, 0,
             0, 0
  },
  {             // 36
     15, 26, 0, 0, 0, 0,
             0x0300, 0x0300, 0x0F60, 0x1FE0,
             0x30E0, 0x3060, 0x3000, 0x3800,
             0x1F80, 0x07E0, 0x70, 0x30,
             0x3030, 0x3870, 0x3FE0, 0x37C0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0, 0
  },
  {             // 37
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0F00, 0x1980,
             0x30C0, 0x30C0, 0x1980, 0x0F00,
             0x70, 0x03C0, 0x0E00, 0x39E0,
             0x0330, 0x0618, 0x0618, 0x0330,
             0x01E0, 0, 0, 0,
             0, 0
  },
  {             // 38
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0x0780,
             0x0FC0, 0x18C0, 0x1800, 0x1800,
             0x0C00, 0x0E00, 0x1F30, 0x1BF0,
             0x31E0, 0x30C0, 0x31E0, 0x3FF8,
             0x1F38, 0, 0, 0,
             0, 0
  },
  {             // 39
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0380, 0x0380,
             0x0700, 0x0600, 0x0C00, 0x0800,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 40
     15, 26, 0, 0, 0, 0,
             0, 0x60, 0xE0, 0xC0,
             0x0180, 0x0180, 0x0180, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0180,
             0x0180, 0x0180, 0xC0, 0xE0,
             0x60, 0
  },
  {             // 41
     15, 26, 0, 0, 0, 0,
             0, 0x1800, 0x1C00, 0x0C00,
             0x0600, 0x0600, 0x0600, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0600,
             0x0600, 0x0600, 0x0C00, 0x1C00,
             0x1800, 0
  },
  {             // 42
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x0300, 0x0300,
             0x3330, 0x3FF0, 0x0FC0, 0x0300,
             0x0FC0, 0x0CC0, 0x1CE0, 0x1860,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 43
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x7FF8, 0x7FF8, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0, 0, 0, 0,
             0, 0
  },
  {             // 44
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0380, 0x0380,
             0x0700, 0x0600, 0x0C00, 0x0800,
             0, 0
  },
  {             // 45
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0x7FF8, 0x7FF8, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 46
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0700, 0x0700,
             0x0700, 0, 0, 0,
             0, 0
  },
  {             // 47
     15, 26, 0, 0, 0, 0,
             0x18, 0x18, 0x30, 0x30,
             0x60, 0x60, 0xC0, 0xC0,
             0x0180, 0x0180, 0x0300, 0x0300,
             0x0600, 0x0600, 0x0C00, 0x0C00,
             0x1800, 0x1800, 0x3000, 0x3000,
             0, 0
  },
  {             // 48
     15, 26, 0, 0, 0, 0,
             0, 0x0780, 0x1FE0, 0x1860,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x1860, 0x1FE0,
             0x0780, 0, 0, 0,
             0, 0
  },
  {             // 49
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x3F00, 0x3F00,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 50
     15, 26, 0, 0, 0, 0,
             0, 0x0FC0, 0x1FE0, 0x3870,
             0x3030, 0x3030, 0x30, 0x70,
             0xE0, 0x01C0, 0x0380, 0x0700,
             0x0E00, 0x1C00, 0x3800, 0x7FF0,
             0x7FF0, 0, 0, 0,
             0, 0
  },
  {             // 51
     15, 26, 0, 0, 0, 0,
             0, 0x0FC0, 0x1FE0, 0x3870,
             0x3030, 0x30, 0x70, 0xE0,
             0x07C0, 0x07E0, 0x70, 0x30,
             0x30, 0x6030, 0x7070, 0x3FE0,
             0x1FC0, 0, 0, 0,
             0, 0
  },
  {             // 52
     15, 26, 0, 0, 0, 0,
             0, 0x01C0, 0x03C0, 0x07C0,
             0x06C0, 0x0CC0, 0x0CC0, 0x18C0,
             0x18C0, 0x30C0, 0x30C0, 0x7FF0,
             0x7FF0, 0xC0, 0xC0, 0x07F0,
             0x07F0, 0, 0, 0,
             0, 0
  },
  {             // 53
     15, 26, 0, 0, 0, 0,
             0, 0x1FF0, 0x1FF0, 0x1800,
             0x1800, 0x1800, 0x1BC0, 0x1FF0,
             0x1C70, 0x38, 0x18, 0x18,
             0x18, 0x3038, 0x3870, 0x1FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 54
     15, 26, 0, 0, 0, 0,
             0, 0x01F0, 0x07F0, 0x0F00,
             0x1C00, 0x1800, 0x3800, 0x37C0,
             0x3FE0, 0x3870, 0x3030, 0x3030,
             0x3030, 0x3830, 0x1C70, 0x1FE0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 55
     15, 26, 0, 0, 0, 0,
             0, 0x3FF0, 0x3FF0, 0x3030,
             0x30, 0x60, 0x60, 0x60,
             0xC0, 0xC0, 0xC0, 0x0180,
             0x0180, 0x0180, 0x0300, 0x0300,
             0x0300, 0, 0, 0,
             0, 0
  },
  {             // 56
     15, 26, 0, 0, 0, 0,
             0, 0x0780, 0x1FE0, 0x3870,
             0x3030, 0x3030, 0x3030, 0x1860,
             0x0FC0, 0x1FE0, 0x3870, 0x3030,
             0x3030, 0x3030, 0x3870, 0x1FE0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 57
     15, 26, 0, 0, 0, 0,
             0, 0x03C0, 0x0FF0, 0x0C30,
             0x1818, 0x1818, 0x1818, 0x1818,
             0x1838, 0x1C78, 0x0FD8, 0x0798,
             0x18, 0x30, 0x70, 0x1FE0,
             0x1F80, 0, 0, 0,
             0, 0
  },
  {             // 58
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0700, 0x0700,
             0x0700, 0, 0, 0,
             0, 0, 0x0700, 0x0700,
             0x0700, 0, 0, 0,
             0, 0
  },
  {             // 59
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0700, 0x0700,
             0x0700, 0, 0, 0,
             0, 0, 0x0700, 0x0700,
             0x0E00, 0x0C00, 0x1800, 0x1000,
             0, 0
  },
  {             // 60
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0x1C, 0x78, 0x01E0, 0x0780,
             0x1E00, 0x7800, 0x7800, 0x1E00,
             0x0780, 0x01E0, 0x78, 0x1C,
             0, 0, 0, 0,
             0, 0
  },
  {             // 61
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0x7FF8,
             0x7FF8, 0, 0, 0x7FF8,
             0x7FF8, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 62
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0x7000, 0x3C00, 0x0F00, 0x03C0,
             0xF0, 0x3C, 0x3C, 0xF0,
             0x03C0, 0x0F00, 0x3C00, 0x7000,
             0, 0, 0, 0,
             0, 0
  },
  {             // 63
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0FC0, 0x1FE0,
             0x1870, 0x1830, 0x1830, 0x30,
             0x70, 0x01E0, 0x0380, 0x0300,
             0x0300, 0, 0x0300, 0x0300,
             0x0300, 0, 0, 0,
             0, 0
  },
  {             // 64
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x1FC0, 0x18C0,
             0x3060, 0x3060, 0x31E0, 0x33E0,
             0x3760, 0x3660, 0x3660, 0x3760,
             0x33F0, 0x31F0, 0x3000, 0x3000,
             0x1860, 0x1FE0, 0x0780, 0,
             0, 0
  },
  {             // 65
     15, 26, 0, 0, 0, 0,
             0, 0, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 66
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7FE0, 0x7FF0,
             0x1838, 0x1818, 0x1818, 0x1838,
             0x1FF0, 0x1FF8, 0x181C, 0x180C,
             0x180C, 0x180C, 0x181C, 0x7FF8,
             0x7FF0, 0, 0, 0,
             0, 0
  },
  {             // 67
     15, 26, 0, 0, 0, 0,
             0, 0, 0x07D8, 0x1FF8,
             0x3838, 0x3018, 0x7018, 0x6000,
             0x6000, 0x6000, 0x6000, 0x6000,
             0x7000, 0x3000, 0x3818, 0x1FF8,
             0x07E0, 0, 0, 0,
             0, 0
  },
  {             // 68
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFFC0, 0xFFF0,
             0x3038, 0x3018, 0x301C, 0x300C,
             0x300C, 0x300C, 0x300C, 0x300C,
             0x300C, 0x3018, 0x3038, 0xFFF0,
             0xFFE0, 0, 0, 0,
             0, 0
  },
  {             // 69
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7FF8, 0x7FF8,
             0x1818, 0x1818, 0x18D8, 0x18C0,
             0x1FC0, 0x1FC0, 0x18C0, 0x18C0,
             0x180C, 0x180C, 0x180C, 0x7FFC,
             0x7FFC, 0, 0, 0,
             0, 0
  },
  {             // 70
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7FFC, 0x7FFC,
             0x180C, 0x180C, 0x18CC, 0x18C0,
             0x1FC0, 0x1FC0, 0x18C0, 0x18C0,
             0x1800, 0x1800, 0x1800, 0x7F80,
             0x7F80, 0, 0, 0,
             0, 0
  },
  {             // 71
     15, 26, 0, 0, 0, 0,
             0, 0, 0x07EC, 0x1FFC,
             0x381C, 0x300C, 0x700C, 0x6000,
             0x6000, 0x6000, 0x60FC, 0x60FC,
             0x700C, 0x300C, 0x381C, 0x1FF8,
             0x07E0, 0, 0, 0,
             0, 0
  },
  {             // 72
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFCFC, 0xFCFC,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3FF0, 0x3FF0, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3030, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 73
     15, 26, 0, 0, 0, 0,
             0, 0, 0x3FF0, 0x3FF0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 74
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0FFC, 0x0FFC,
             0x60, 0x60, 0x60, 0x60,
             0x60, 0x60, 0x60, 0x6060,
             0x6060, 0x6060, 0x70E0, 0x3FC0,
             0x1F80, 0, 0, 0,
             0, 0
  },
  {             // 75
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFCF8, 0xFCF8,
             0x30E0, 0x31C0, 0x3380, 0x3700,
             0x3E00, 0x3F00, 0x3B80, 0x31C0,
             0x30E0, 0x3060, 0x3070, 0xFC3C,
             0xFC3C, 0, 0, 0,
             0, 0
  },
  {             // 76
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7F80, 0x7F80,
             0x0C00, 0x0C00, 0x0C00, 0x0C00,
             0x0C00, 0x0C00, 0x0C00, 0x0C00,
             0x0C18, 0x0C18, 0x0C18, 0x7FF8,
             0x7FF8, 0, 0, 0,
             0, 0
  },
  {             // 77
     15, 26, 0, 0, 0, 0,
             0, 0, 0xF03C, 0xF03C,
             0x7878, 0x7878, 0x6CD8, 0x6CD8,
             0x6CD8, 0x6798, 0x6318, 0x6318,
             0x6018, 0x6018, 0x6018, 0xF87C,
             0xF87C, 0, 0, 0,
             0, 0
  },
  {             // 78
     15, 26, 0, 0, 0, 0,
             0, 0, 0x787C, 0x787C,
             0x3C18, 0x3C18, 0x3618, 0x3618,
             0x3318, 0x3318, 0x3198, 0x3198,
             0x30D8, 0x30D8, 0x3078, 0x7C78,
             0x7C38, 0, 0, 0,
             0, 0
  },
  {             // 79
     15, 26, 0, 0, 0, 0,
             0, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 80
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7FE0, 0x7FF8,
             0x181C, 0x180C, 0x180C, 0x180C,
             0x180C, 0x181C, 0x1FF8, 0x1FE0,
             0x1800, 0x1800, 0x1800, 0x7F80,
             0x7F80, 0, 0, 0,
             0, 0
  },
  {             // 81
     15, 26, 0, 0, 0, 0,
             0, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0x070C, 0x1FFC, 0x1CF0,
             0, 0
  },
  {             // 82
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFF80, 0xFFE0,
             0x3070, 0x3030, 0x3030, 0x3030,
             0x3070, 0x3FE0, 0x3F80, 0x31C0,
             0x30E0, 0x3060, 0x3070, 0xFC3C,
             0xFC3C, 0, 0, 0,
             0, 0
  },
  {             // 83
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0FD8, 0x1FF8,
             0x3838, 0x3018, 0x3018, 0x3800,
             0x1F00, 0x0FE0, 0x01F0, 0x38,
             0x6018, 0x6018, 0x7038, 0x7FF0,
             0x6FE0, 0, 0, 0,
             0, 0
  },
  {             // 84
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7FF8, 0x7FF8,
             0x6318, 0x6318, 0x6318, 0x6318,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x1FE0,
             0x1FE0, 0, 0, 0,
             0, 0
  },
  {             // 85
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7C7C, 0x7C7C,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x1830, 0x1FF0,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 86
     15, 26, 0, 0, 0, 0,
             0, 0, 0xF87C, 0xF87C,
             0x6018, 0x6018, 0x3030, 0x3030,
             0x3030, 0x1860, 0x1860, 0x1860,
             0x0CC0, 0x0CC0, 0x0780, 0x0780,
             0x0780, 0, 0, 0,
             0, 0
  },
  {             // 87
     15, 26, 0, 0, 0, 0,
             0, 0, 0xF87C, 0xF87C,
             0x6018, 0x6318, 0x6318, 0x6798,
             0x6798, 0x6FD8, 0x6CD8, 0x6CD8,
             0x3CF0, 0x3870, 0x3870, 0x3870,
             0x3870, 0, 0, 0,
             0, 0
  },
  {             // 88
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFCFC, 0xFCFC,
             0x7038, 0x3870, 0x1CE0, 0x0FC0,
             0x0780, 0x0300, 0x0780, 0x0CC0,
             0x1CE0, 0x3870, 0x7038, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 89
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFCFC, 0xFCFC,
             0x7038, 0x3870, 0x1860, 0x0CC0,
             0x0FC0, 0x0780, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x1FE0,
             0x1FE0, 0, 0, 0,
             0, 0
  },
  {             // 90
     15, 26, 0, 0, 0, 0,
             0, 0, 0x3FF8, 0x3FF8,
             0x3038, 0x3070, 0x30E0, 0xC0,
             0x01C0, 0x0380, 0x0700, 0x0600,
             0x0E18, 0x1C18, 0x3818, 0x3FF8,
             0x3FF8, 0, 0, 0,
             0, 0
  },
  {             // 91
     15, 26, 0, 0, 0, 0,
             0, 0x03E0, 0x03E0, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x03E0,
             0x03E0, 0
  },
  {             // 92
     15, 26, 0, 0, 0, 0,
             0x3000, 0x3000, 0x1800, 0x1800,
             0x0C00, 0x0C00, 0x0600, 0x0600,
             0x0300, 0x0300, 0x0180, 0x0180,
             0xC0, 0xC0, 0x60, 0x60,
             0x30, 0x30, 0x18, 0x18,
             0, 0
  },
  {             // 93
     15, 26, 0, 0, 0, 0,
             0, 0x1F00, 0x1F00, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x1F00,
             0x1F00, 0
  },
  {             // 94
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x0300, 0x0780,
             0x0780, 0x0CC0, 0x0CC0, 0x1860,
             0x1860, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 95
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0xFFFE,
             0xFFFE, 0
  },
  {             // 96
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0700, 0x0700,
             0x0380, 0x0180, 0xC0, 0x40,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 97
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 98
     15, 26, 0, 0, 0, 0,
             0, 0x7800, 0x7800, 0x1800,
             0x1800, 0x1800, 0x1BE0, 0x1FF8,
             0x1E38, 0x1C1C, 0x180C, 0x180C,
             0x180C, 0x1C1C, 0x1E38, 0x7FF8,
             0x7BE0, 0, 0, 0,
             0, 0
  },
  {             // 99
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FD8, 0x3FF8,
             0x3878, 0x7038, 0x6018, 0x6000,
             0x6000, 0x7000, 0x3838, 0x3FF8,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 100
     15, 26, 0, 0, 0, 0,
             0, 0xF0, 0xF0, 0x30,
             0x30, 0x30, 0x0FB0, 0x3FF0,
             0x38F0, 0x7070, 0x6030, 0x6030,
             0x6030, 0x7070, 0x38F0, 0x3FFC,
             0x0FBC, 0, 0, 0,
             0, 0
  },
  {             // 101
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x7FF8,
             0x7FF8, 0x7000, 0x3838, 0x3FF8,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 102
     15, 26, 0, 0, 0, 0,
             0, 0x01F8, 0x03F8, 0x0700,
             0x0600, 0x0600, 0x3FF0, 0x3FF0,
             0x0600, 0x0600, 0x0600, 0x0600,
             0x0600, 0x0600, 0x0600, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 103
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FBC, 0x3FFC,
             0x38F0, 0x7070, 0x6030, 0x6030,
             0x6030, 0x7070, 0x38F0, 0x3FF0,
             0x0FB0, 0x30, 0x30, 0x70,
             0x1FE0, 0x1FC0
  },
  {             // 104
     15, 26, 0, 0, 0, 0,
             0, 0xF000, 0xF000, 0x3000,
             0x3000, 0x3000, 0x37C0, 0x3FE0,
             0x3C70, 0x3830, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3030, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 105
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x0700, 0x0700,
             0, 0, 0x1F00, 0x1F00,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 106
     15, 26, 0, 0, 0, 0,
             0, 0x0380, 0x0380, 0x0380,
             0, 0, 0x3FC0, 0x3FC0,
             0xC0, 0xC0, 0xC0, 0xC0,
             0xC0, 0xC0, 0xC0, 0xC0,
             0xC0, 0xC0, 0xC0, 0x01C0,
             0x3F80, 0x3F00
  },
  {             // 107
     15, 26, 0, 0, 0, 0,
             0, 0x7800, 0x7800, 0x1800,
             0x1800, 0x1800, 0x18F0, 0x18F0,
             0x19C0, 0x1B80, 0x1F00, 0x1F00,
             0x1B80, 0x19C0, 0x18E0, 0x78FC,
             0x78FC, 0, 0, 0,
             0, 0
  },
  {             // 108
     15, 26, 0, 0, 0, 0,
             0, 0x1F00, 0x1F00, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 109
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x01DEF0, 0x01FFF8,
             0x7398, 0x6318, 0x6318, 0x6318,
             0x6318, 0x6318, 0x6318, 0x01F3DE,
             0x01F3DE, 0, 0, 0,
             0, 0
  },
  {             // 110
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0xF3C0, 0xF7E0,
             0x3C70, 0x3830, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3030, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 111
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 112
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0xF7C0, 0xFFF0,
             0x3C70, 0x3838, 0x3018, 0x3018,
             0x3018, 0x3838, 0x3C70, 0x3FF0,
             0x37C0, 0x3000, 0x3000, 0x3000,
             0xFE00, 0xFE00
  },
  {             // 113
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FBC, 0x3FFC,
             0x38F0, 0x7070, 0x6030, 0x6030,
             0x6030, 0x7070, 0x38F0, 0x3FF0,
             0x0FB0, 0x30, 0x30, 0x30,
             0x01FC, 0x01FC
  },
  {             // 114
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x3CF0, 0x3FF8,
             0x0F18, 0x0E00, 0x0C00, 0x0C00,
             0x0C00, 0x0C00, 0x0C00, 0x7FE0,
             0x7FE0, 0, 0, 0,
             0, 0
  },
  {             // 115
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FB0, 0x1FF0,
             0x3870, 0x3830, 0x1F00, 0x07C0,
             0x01F0, 0x3038, 0x3838, 0x3FF0,
             0x37E0, 0, 0, 0,
             0, 0
  },
  {             // 116
     15, 26, 0, 0, 0, 0,
             0, 0, 0x1800, 0x1800,
             0x1800, 0x1800, 0x7FE0, 0x7FE0,
             0x1800, 0x1800, 0x1800, 0x1800,
             0x1800, 0x1800, 0x1C70, 0x0FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 117
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0xF0F0, 0xF0F0,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3870, 0x1FFC,
             0x0FBC, 0, 0, 0,
             0, 0
  },
  {             // 118
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0xFCFC, 0xFCFC,
             0x3030, 0x3030, 0x1860, 0x1860,
             0x0CC0, 0x0CC0, 0x0780, 0x0780,
             0x0300, 0, 0, 0,
             0, 0
  },
  {             // 119
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0xF87C, 0xF87C,
             0x6318, 0x6318, 0x3330, 0x37B0,
             0x37B0, 0x3CF0, 0x1CE0, 0x1860,
             0x1860, 0, 0, 0,
             0, 0
  },
  {             // 120
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x7CF8, 0x7CF8,
             0x1860, 0x0CC0, 0x0780, 0x0300,
             0x0780, 0x0CC0, 0x1860, 0x7CF8,
             0x7CF8, 0, 0, 0,
             0, 0
  },
  {             // 121
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x7CF8, 0x7CF8,
             0x3030, 0x3870, 0x1860, 0x1CE0,
             0x0CC0, 0x0DC0, 0x0780, 0x0780,
             0x0300, 0x0700, 0x0600, 0x0E00,
             0x7F00, 0x7F00
  },
  {             // 122
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x3FF0, 0x3FF0,
             0x30E0, 0x31C0, 0x0380, 0x0700,
             0x0E00, 0x1C30, 0x3830, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 123
     15, 26, 0, 0, 0, 0,
             0, 0xE0, 0x0180, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0700, 0x0E00, 0x0700,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0180,
             0xE0, 0
  },
  {             // 124
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0,
             0, 0
  },
  {             // 125
     15, 26, 0, 0, 0, 0,
             0, 0x1C00, 0x0600, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0380, 0x01C0, 0x0380,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0600,
             0x1C00, 0
  },
  {             // 126
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0x1E18, 0x3F38, 0x73F0, 0x61E0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 127
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 128
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 129
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 130
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 131
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 132
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 133
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 134
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 135
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 136
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 137
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 138
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 139
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 140
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 141
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 142
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 143
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 144
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 145
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 146
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 147
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 148
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 149
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 150
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 151
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 152
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 153
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 154
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 155
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 156
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 157
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 158
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 159
     0, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 160
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 161
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0600, 0x0600,
             0x0600, 0, 0x0600, 0x0600,
             0x0600, 0x0600, 0x0600, 0x0F00,
             0x0F00, 0x0F00, 0x0F00, 0x0F00,
             0x0F00, 0x0600
  },
  {             // 162
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x0300, 0x0300,
             0x0F60, 0x1FE0, 0x38E0, 0x3060,
             0x3000, 0x3000, 0x3000, 0x3860,
             0x1FE0, 0x0FC0, 0x0300, 0x0300,
             0x0300, 0, 0, 0,
             0, 0
  },
  {             // 163
     15, 26, 0, 0, 0, 0,
             0, 0, 0x07C0, 0x0FE0,
             0x1C60, 0x1800, 0x1800, 0x1800,
             0x1800, 0x7F80, 0x7F80, 0x0C00,
             0x0C00, 0x1C00, 0x3818, 0x7FF8,
             0x7FF0, 0, 0, 0,
             0, 0
  },
  {             // 164
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0x3030, 0x3FF0, 0x1FE0, 0x3870,
             0x3030, 0x3030, 0x3030, 0x3870,
             0x1FE0, 0x3FF0, 0x3030, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 165
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7CF8, 0x7CF8,
             0x3870, 0x1860, 0x1CE0, 0x0CC0,
             0x0780, 0x0780, 0x1FE0, 0x0300,
             0x1FE0, 0x0300, 0x0300, 0x1FE0,
             0x1FE0, 0, 0, 0,
             0, 0
  },
  {             // 166
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0, 0, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0,
             0, 0
  },
  {             // 167
     15, 26, 0, 0, 0, 0,
             0, 0x07F0, 0x0FF0, 0x1C30,
             0x1830, 0x1C00, 0x3F00, 0x67C0,
             0x61F0, 0x7878, 0x3E18, 0x0F98,
             0x03F8, 0xF0, 0x60, 0x3060,
             0x30E0, 0x3FC0, 0x3F80, 0,
             0, 0
  },
  {             // 168
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 169
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0780, 0x1FE0,
             0x3870, 0x6798, 0x6FD8, 0xDCCC,
             0xD80C, 0xD80C, 0xDCCC, 0x6FD8,
             0x6798, 0x3870, 0x1FE0, 0x0780,
             0, 0, 0, 0,
             0, 0
  },
  {             // 170
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0780, 0x0CC0,
             0xC0, 0x0FC0, 0x18C0, 0x18C0,
             0x19E0, 0x0F60, 0, 0x1FE0,
             0x1FE0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 171
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0x071C,
             0x0E38, 0x1C70, 0x38E0, 0x71C0,
             0x38E0, 0x1C70, 0x0E38, 0x071C,
             0, 0, 0, 0,
             0, 0
  },
  {             // 172
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0x7FF8,
             0x7FF8, 0x18, 0x18, 0x18,
             0x18, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 173
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0x3FF8, 0x3FF8, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 174
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0780, 0x1FE0,
             0x3870, 0x6F98, 0x6FD8, 0xCCCC,
             0xCCCC, 0xCF8C, 0xCD8C, 0x6CD8,
             0x6CD8, 0x3870, 0x1FE0, 0x0780,
             0, 0, 0, 0,
             0, 0
  },
  {             // 175
     15, 26, 0, 0, 0, 0,
             0, 0, 0x1FC0, 0x1FC0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 176
     15, 26, 0, 0, 0, 0,
             0, 0x0780, 0x0CC0, 0x1860,
             0x1860, 0x1860, 0x0CC0, 0x0780,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 177
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0x0300,
             0x0300, 0x0300, 0x0300, 0x7FF8,
             0x7FF8, 0x0300, 0x0300, 0x0300,
             0x0300, 0, 0, 0x7FF8,
             0x7FF8, 0, 0, 0,
             0, 0
  },
  {             // 178
     15, 26, 0, 0, 0, 0,
             0, 0x07C0, 0x0C60, 0x0C60,
             0xC0, 0x0180, 0x0300, 0x0600,
             0x0C60, 0x0FE0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 179
     15, 26, 0, 0, 0, 0,
             0, 0x07C0, 0x0C60, 0x0C60,
             0xC0, 0x03C0, 0x60, 0x0C60,
             0x0C60, 0x07C0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 180
     15, 26, 0, 0, 0, 0,
             0, 0x01C0, 0x0380, 0x0700,
             0x0E00, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 181
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0xF0F0, 0xF0F0,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3870, 0x3FFC,
             0x3FBC, 0x3000, 0x3000, 0x3000,
             0x3000, 0x3000
  },
  {             // 182
     15, 26, 0, 0, 0, 0,
             0, 0x0FF8, 0x3FF8, 0x7360,
             0x7360, 0x7360, 0x7360, 0x7360,
             0x3F60, 0x0F60, 0x0360, 0x0360,
             0x0360, 0x0360, 0x0360, 0x0360,
             0x0360, 0x1F78, 0x1F78, 0,
             0, 0
  },
  {             // 183
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0x0700, 0x0700, 0x0700, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 184
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0x0300, 0x0300, 0x0780, 0x0180,
             0x0F80, 0x0700
  },
  {             // 185
     15, 26, 0, 0, 0, 0,
             0, 0x0300, 0x1F00, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x1FE0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 186
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0780, 0x0FC0,
             0x1860, 0x1860, 0x1860, 0x1860,
             0x0FC0, 0x0780, 0, 0x1FE0,
             0x1FE0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 187
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0, 0x71C0,
             0x38E0, 0x1C70, 0x0E38, 0x071C,
             0x0E38, 0x1C70, 0x38E0, 0x71C0,
             0, 0, 0, 0,
             0, 0
  },
  {             // 188
     15, 26, 0, 0, 0, 0,
             0, 0x3000, 0x01F002, 0x3006,
             0x300C, 0x3018, 0x3030, 0x3060,
             0x30C8, 0x01FF98, 0x0338, 0x0658,
             0x0C98, 0x1918, 0x31FC, 0x6018,
             0x403C, 0, 0, 0,
             0, 0
  },
  {             // 189
     15, 26, 0, 0, 0, 0,
             0, 0x3000, 0x01F002, 0x3006,
             0x300C, 0x3018, 0x3030, 0x3060,
             0x30FC, 0x01FFE6, 0x0346, 0x060C,
             0x0C18, 0x1830, 0x3060, 0x60C6,
             0x40FE, 0, 0, 0,
             0, 0
  },
  {             // 190
     15, 26, 0, 0, 0, 0,
             0, 0x7C00, 0xC602, 0xC606,
             0x0C0C, 0x3C18, 0x0630, 0xC660,
             0xC6C8, 0x7D98, 0x0338, 0x0658,
             0x0C98, 0x1918, 0x31FC, 0x6018,
             0x403C, 0, 0, 0,
             0, 0
  },
  {             // 191
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0300, 0x0300,
             0x0300, 0, 0x0300, 0x0300,
             0x0700, 0x1E00, 0x3800, 0x3000,
             0x3060, 0x3060, 0x3860, 0x1FE0,
             0x0FC0, 0
  },
  {             // 192
     15, 26, 0, 0x3800, 0x1C00, 0x0E00,
             0x0700, 0, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 193
     15, 26, 0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 194
     15, 26, 0x0600, 0x0F00, 0x1F80, 0x39C0,
             0x70E0, 0, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 195
     15, 26, 0, 0, 0x0E60, 0x1FC0,
             0x3380, 0, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 196
     15, 26, 0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 197
     15, 26, 0, 0x0700, 0x0D80, 0x0880,
             0x0D80, 0x0700, 0x3F00, 0x3F00,
             0x0780, 0x0780, 0x0CC0, 0x0CC0,
             0x1CE0, 0x1860, 0x1860, 0x3FF0,
             0x3FF0, 0x7038, 0x6018, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 198
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0FFE, 0x0FFE,
             0x0386, 0x0786, 0x0780, 0x0D98,
             0x09F8, 0x19F8, 0x1F98, 0x3F80,
             0x3180, 0x6186, 0x6186, 0xF7FE,
             0xF7FE, 0, 0, 0,
             0, 0
  },
  {             // 199
     15, 26, 0, 0, 0, 0,
             0, 0, 0x07D8, 0x1FF8,
             0x3838, 0x3018, 0x7018, 0x6000,
             0x6000, 0x6000, 0x6000, 0x6000,
             0x7000, 0x3008, 0x3818, 0x1FF0,
             0x07E0, 0x0300, 0x0780, 0x0180,
             0x0F80, 0x0700
  },
  {             // 200
     15, 26, 0, 0x1C00, 0x0E00, 0x0700,
             0x0380, 0, 0x7FF8, 0x7FF8,
             0x1818, 0x1818, 0x18D8, 0x18C0,
             0x1FC0, 0x1FC0, 0x18C0, 0x18C0,
             0x180C, 0x180C, 0x180C, 0x7FFC,
             0x7FFC, 0, 0, 0,
             0, 0
  },
  {             // 201
     15, 26, 0, 0x70, 0xE0, 0x01C0,
             0x0380, 0, 0x7FF8, 0x7FF8,
             0x1818, 0x1818, 0x18D8, 0x18C0,
             0x1FC0, 0x1FC0, 0x18C0, 0x18C0,
             0x180C, 0x180C, 0x180C, 0x7FFC,
             0x7FFC, 0, 0, 0,
             0, 0
  },
  {             // 202
     15, 26, 0x0180, 0x03C0, 0x07E0, 0x0E70,
             0x1C38, 0, 0x7FF8, 0x7FF8,
             0x1818, 0x1818, 0x18D8, 0x18C0,
             0x1FC0, 0x1FC0, 0x18C0, 0x18C0,
             0x180C, 0x180C, 0x180C, 0x7FFC,
             0x7FFC, 0, 0, 0,
             0, 0
  },
  {             // 203
     15, 26, 0, 0, 0x0C60, 0x0C60,
             0x0C60, 0, 0x7FF8, 0x7FF8,
             0x1818, 0x1818, 0x18D8, 0x18C0,
             0x1FC0, 0x1FC0, 0x18C0, 0x18C0,
             0x180C, 0x180C, 0x180C, 0x7FFC,
             0x7FFC, 0, 0, 0,
             0, 0
  },
  {             // 204
     15, 26, 0, 0x1C00, 0x0E00, 0x0700,
             0x0380, 0, 0x3FF0, 0x3FF0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 205
     15, 26, 0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0x3FF0, 0x3FF0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 206
     15, 26, 0x0300, 0x0780, 0x0FC0, 0x1CE0,
             0x3870, 0, 0x3FF0, 0x3FF0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 207
     15, 26, 0, 0, 0x0CC0, 0x0CC0,
             0x0CC0, 0, 0x3FF0, 0x3FF0,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 208
     15, 26, 0, 0, 0, 0,
             0, 0, 0xFFC0, 0xFFF0,
             0x3038, 0x3018, 0x301C, 0x300C,
             0xFE0C, 0xFE0C, 0x300C, 0x300C,
             0x300C, 0x3018, 0x3038, 0xFFF0,
             0xFFE0, 0, 0, 0,
             0, 0
  },
  {             // 209
     15, 26, 0, 0, 0x0730, 0x0FE0,
             0x19C0, 0, 0x787C, 0x787C,
             0x3C18, 0x3C18, 0x3618, 0x3618,
             0x3318, 0x3318, 0x3198, 0x3198,
             0x30D8, 0x30D8, 0x3078, 0x7C78,
             0x7C38, 0, 0, 0,
             0, 0
  },
  {             // 210
     15, 26, 0, 0x0E00, 0x0700, 0x0380,
             0x01C0, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 211
     15, 26, 0, 0x70, 0xE0, 0x01C0,
             0x0380, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 212
     15, 26, 0x0180, 0x03C0, 0x07E0, 0x0E70,
             0x1C38, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 213
     15, 26, 0, 0, 0x0730, 0x0FE0,
             0x19C0, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 214
     15, 26, 0, 0, 0x0C60, 0x0C60,
             0x0C60, 0, 0x07C0, 0x1FF0,
             0x3838, 0x3018, 0x701C, 0x600C,
             0x600C, 0x600C, 0x600C, 0x600C,
             0x701C, 0x3018, 0x3838, 0x1FF0,
             0x07C0, 0, 0, 0,
             0, 0
  },
  {             // 215
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0x2010, 0x7038, 0x3870, 0x1CE0,
             0x0FC0, 0x0780, 0x0780, 0x0FC0,
             0x1CE0, 0x3870, 0x7038, 0x2010,
             0, 0, 0, 0,
             0, 0
  },
  {             // 216
     15, 26, 0, 0, 0, 0,
             0x0C, 0x18, 0x07F0, 0x1FF0,
             0x3838, 0x3078, 0x70DC, 0x608C,
             0x618C, 0x630C, 0x620C, 0x660C,
             0x741C, 0x3C18, 0x3838, 0x1FF0,
             0x37C0, 0x6000, 0, 0,
             0, 0
  },
  {             // 217
     15, 26, 0, 0x1C00, 0x0E00, 0x0700,
             0x0380, 0, 0x7C7C, 0x7C7C,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x1830, 0x1FF0,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 218
     15, 26, 0, 0x70, 0xE0, 0x01C0,
             0x0380, 0, 0x7C7C, 0x7C7C,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x1830, 0x1FF0,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 219
     15, 26, 0x0180, 0x03C0, 0x07E0, 0x0E70,
             0x1C38, 0, 0x7C7C, 0x7C7C,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x1830, 0x1FF0,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 220
     15, 26, 0, 0, 0x0C60, 0x0C60,
             0x0C60, 0, 0x7C7C, 0x7C7C,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x3018, 0x3018,
             0x3018, 0x3018, 0x1830, 0x1FF0,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 221
     15, 26, 0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0xFCFC, 0xFCFC,
             0x7038, 0x3870, 0x1860, 0x0CC0,
             0x0FC0, 0x0780, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x1FE0,
             0x1FE0, 0, 0, 0,
             0, 0
  },
  {             // 222
     15, 26, 0, 0, 0, 0,
             0, 0, 0x7E00, 0x7E00,
             0x1800, 0x1FE0, 0x1FF8, 0x181C,
             0x180C, 0x180C, 0x180C, 0x181C,
             0x1FF8, 0x1FE0, 0x1800, 0x7E00,
             0x7E00, 0, 0, 0,
             0, 0
  },
  {             // 223
     15, 26, 0, 0, 0, 0,
             0, 0x0780, 0x0FC0, 0x1CE0,
             0x1860, 0x1860, 0x18E0, 0x1BC0,
             0x1BE0, 0x1870, 0x1838, 0x1818,
             0x1818, 0x1818, 0x19B8, 0x7DF0,
             0x7CE0, 0, 0, 0,
             0, 0
  },
  {             // 224
     15, 26, 0, 0, 0, 0,
             0, 0x3800, 0x1C00, 0x0E00,
             0x0700, 0, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 225
     15, 26, 0, 0, 0, 0,
             0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 226
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x0F80, 0x1DC0,
             0x38E0, 0, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 227
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0E60, 0x1FC0,
             0x3380, 0, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 228
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 229
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x0D80, 0x0880,
             0x0D80, 0x0700, 0x1F80, 0x3FC0,
             0x30E0, 0x60, 0x0FE0, 0x3FE0,
             0x7060, 0x6060, 0x60E0, 0x7FF8,
             0x3F78, 0, 0, 0,
             0, 0
  },
  {             // 230
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x3CF0, 0x7FF8,
             0x679C, 0x030C, 0x1F0C, 0x7FFC,
             0xE3FC, 0xC300, 0xC78C, 0xFFFC,
             0x7CF0, 0, 0, 0,
             0, 0
  },
  {             // 231
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0, 0x0FB0, 0x3FF0,
             0x3870, 0x7030, 0x6030, 0x6000,
             0x6000, 0x7000, 0x3830, 0x3FF0,
             0x0FE0, 0x0300, 0x0780, 0x0180,
             0x0F80, 0x0700
  },
  {             // 232
     15, 26, 0, 0, 0, 0,
             0, 0x1C00, 0x0E00, 0x0700,
             0x0380, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x7FF8,
             0x7FF8, 0x7000, 0x3838, 0x3FF8,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 233
     15, 26, 0, 0, 0, 0,
             0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x7FF8,
             0x7FF8, 0x7000, 0x3838, 0x3FF8,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 234
     15, 26, 0, 0, 0, 0,
             0, 0x0380, 0x07C0, 0x0EE0,
             0x1C70, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x7FF8,
             0x7FF8, 0x7000, 0x3838, 0x3FF8,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 235
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x7FF8,
             0x7FF8, 0x7000, 0x3838, 0x3FF8,
             0x0FE0, 0, 0, 0,
             0, 0
  },
  {             // 236
     15, 26, 0, 0, 0, 0,
             0, 0x3800, 0x1C00, 0x0E00,
             0x0700, 0, 0x1F00, 0x1F00,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 237
     15, 26, 0, 0, 0, 0,
             0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0x1F00, 0x1F00,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 238
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x0F80, 0x1DC0,
             0x38E0, 0, 0x1F00, 0x1F00,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 239
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0x1F00, 0x1F00,
             0x0300, 0x0300, 0x0300, 0x0300,
             0x0300, 0x0300, 0x0300, 0x3FF0,
             0x3FF0, 0, 0, 0,
             0, 0
  },
  {             // 240
     15, 26, 0, 0, 0, 0,
             0xF000, 0xFC70, 0x0FF0, 0x1F80,
             0x7DC0, 0x70E0, 0x0FF0, 0x3FF0,
             0x3878, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 241
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0E60, 0x1FC0,
             0x3380, 0, 0xF3C0, 0xF7E0,
             0x3C70, 0x3830, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3030, 0xFCFC,
             0xFCFC, 0, 0, 0,
             0, 0
  },
  {             // 242
     15, 26, 0, 0, 0, 0,
             0, 0x1C00, 0x0E00, 0x0700,
             0x0380, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 243
     15, 26, 0, 0, 0, 0,
             0, 0xE0, 0x01C0, 0x0380,
             0x0700, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 244
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x0F80, 0x1DC0,
             0x38E0, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 245
     15, 26, 0, 0, 0, 0,
             0, 0, 0x0E60, 0x1FC0,
             0x3380, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 246
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0x0FC0, 0x3FF0,
             0x3870, 0x7038, 0x6018, 0x6018,
             0x6018, 0x7038, 0x3870, 0x3FF0,
             0x0FC0, 0, 0, 0,
             0, 0
  },
  {             // 247
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0x0700, 0x0700, 0x0700, 0,
             0, 0xFFF8, 0xFFF8, 0,
             0, 0x0700, 0x0700, 0x0700,
             0, 0, 0, 0,
             0, 0
  },
  {             // 248
     15, 26, 0, 0, 0, 0,
             0, 0, 0, 0,
             0, 0x0C, 0x0FD8, 0x3FF0,
             0x3870, 0x70D8, 0x6198, 0x6318,
             0x6618, 0x6C38, 0x3870, 0x3FF0,
             0x3FC0, 0x6000, 0xC000, 0,
             0, 0
  },
  {             // 249
     15, 26, 0, 0, 0, 0,
             0, 0x3800, 0x1C00, 0x0E00,
             0x0700, 0, 0xF0F0, 0xF0F0,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3870, 0x1FFC,
             0x0FBC, 0, 0, 0,
             0, 0
  },
  {             // 250
     15, 26, 0, 0, 0, 0,
             0, 0x01C0, 0x0380, 0x0700,
             0x0E00, 0, 0xF0F0, 0xF0F0,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3870, 0x1FFC,
             0x0FBC, 0, 0, 0,
             0, 0
  },
  {             // 251
     15, 26, 0, 0, 0, 0,
             0, 0x0700, 0x0F80, 0x1DC0,
             0x38E0, 0, 0xF0F0, 0xF0F0,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3870, 0x1FFC,
             0x0FBC, 0, 0, 0,
             0, 0
  },
  {             // 252
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0xF0F0, 0xF0F0,
             0x3030, 0x3030, 0x3030, 0x3030,
             0x3030, 0x3030, 0x3870, 0x1FFC,
             0x0FBC, 0, 0, 0,
             0, 0
  },
  {             // 253
     15, 26, 0, 0, 0, 0,
             0, 0x70, 0xE0, 0x01C0,
             0x0380, 0, 0x7CF8, 0x7CF8,
             0x3030, 0x3870, 0x1860, 0x1CE0,
             0x0CC0, 0x0DC0, 0x0780, 0x0780,
             0x0300, 0x0700, 0x0600, 0x0E00,
             0x7F00, 0x7F00
  },
  {             // 254
     15, 26, 0, 0, 0, 0,
             0, 0x7800, 0x7800, 0x1800,
             0x1800, 0x1800, 0x1BE0, 0x1FF8,
             0x1E38, 0x1C1C, 0x180C, 0x180C,
             0x180C, 0x1C1C, 0x1E38, 0x1FF8,
             0x1BE0, 0x1800, 0x1800, 0x1800,
             0x7F00, 0x7F00
  },
  {             // 255
     15, 26, 0, 0, 0, 0,
             0, 0, 0x18C0, 0x18C0,
             0x18C0, 0, 0x7CF8, 0x7CF8,
             0x3030, 0x3870, 0x1860, 0x1CE0,
             0x0CC0, 0x0DC0, 0x0780, 0x0780,
             0x0300, 0x0700, 0x0600, 0x0E00,
             0x7F00, 0x7F00
  },
};
